local function SpeedRun(player)
	local speedrun = P_SpawnMobj(player.mo.x + (P_RandomRange(-36,36) * player.mo.scale),
	player.mo.y + (P_RandomRange(-36,36) * player.mo.scale),
	player.mo.z + (player.mo.height/2) + (P_RandomRange(-20,20) * player.mo.scale), MT_SMOKE)
	if speedrun and speedrun.valid
		speedrun.state = S_SCARFSPEED
		speedrun.angle = player.drawangle
		speedrun.momx = 3*player.mo.momx/4
		speedrun.momy = 3*player.mo.momy/4
		speedrun.momz = 3*player.mo.momz/4
		speedrun.scale = player.mo.scale
		speedrun.color = SKINCOLOR_WHITE
		speedrun.colorized = true
		speedrun.blendmode = AST_ADD
	end
end

//SMS Reborn mod
rawset(_G, "SpeedSneakers", function(s, fuse, noflicker)
	local auraghost = P_SpawnGhostMobj(s)
	auraghost.blendmode = AST_ADD
	auraghost.scalespeed = $/2
	auraghost.destscale = auraghost.scalespeed+1
	auraghost.rollangle = s.rollangle
	auraghost.color = SKINCOLOR_RED
	auraghost.colorized = true
	if fuse	
		auraghost.fuse = fuse
		auraghost.tics = fuse+8	
	end
	if not noflicker
		if (leveltime % 2 == 0)
			auraghost.momx = s.momx/2 
			auraghost.momy = s.momy/2
			auraghost.momz = s.momz/2
		elseif (leveltime % 3 == 0) 
			auraghost.momx = s.momx/5 
			auraghost.momy = s.momy/5
			auraghost.momz = s.momz/5		
		end
	end
	return auraghost
end)

addHook("FollowMobj", function(player, mobj)
	local mo = player.mo
	if not (mo and mo.valid and mobj and mobj.valid) 
		return true 
	end
	mobj.flags2 = $&~MF2_LINKDRAW
	if player.powers[pw_super] 
	and player.armaform
		mobj.skin = mo.skin
		mobj.rollangle = mo.rollangle
		mobj.mirrored = mo.mirrored
		mobj.spritexscale = mo.spritexscale
		mobj.spriteyscale = mo.spriteyscale
		mobj.spritexoffset = mo.spritexoffset
		mobj.spriteyoffset = mo.spriteyoffset
		mobj.renderflags = $|RF_FULLBRIGHT
		mobj.sprite2 = mo.sprite2
		mobj.angle = player.drawangle
		if (leveltime % 8 == 0)
			mobj.state = S_SCARFAURA
			mobj.scale = mo.scale
			mobj.flags2 = mo.flags2&(MF2_DONTDRAW|MF2_OBJECTFLIP)
			mobj.eflags = mo.eflags&MFE_VERTICALFLIP
			mobj.blendmode = AST_ADD
			mobj.color = SKINCOLOR_KETCHUP
			mobj.colorized = true
			mobj.frame = $ & ~FF_TRANSMASK | TR_TRANS50
			mobj.fuse = 0
			mobj.tics = 10
			mobj.target = player.mo
			mobj.fuse = 0
		end
	end
	if not player.powers[pw_super] 
	and not player.armaform
		mobj.state = S_INVISIBLE
	end
end, MT_SCARF_AURA)

local function MaxSpeedRun(player)
	local speedrun2 = P_SpawnMobj(player.mo.x + (P_RandomRange(-36,36) * player.mo.scale),
	player.mo.y + (P_RandomRange(-36,36) * player.mo.scale),
	player.mo.z + (player.mo.height/2) + (P_RandomRange(-20,20) * player.mo.scale), MT_SMOKE)
	if speedrun2 and speedrun2.valid
		speedrun2.state = S_MAXSCARFSPEED1
		speedrun2.angle = player.drawangle
		speedrun2.momx = 3*player.mo.momx/4
		speedrun2.momy = 3*player.mo.momy/4
		speedrun2.momz = 3*player.mo.momz/4
		speedrun2.scale = player.mo.scale
		speedrun2.color = SKINCOLOR_WHITE
		speedrun2.colorized = true
		speedrun2.blendmode = AST_ADD
	end
end

local function scarffloat(mo, trailmo, freq)
    if not mo.prevz or not mo.prevleveltime or (mo.prevleveltime ~= leveltime - 1) then
       mo.prevz = mo.z
    end
    local rmomz = mo.z - mo.prevz
    mo.prevz = mo.z
    mo.prevleveltime = leveltime
    local mospeed = R_PointToDist2(0, 0, R_PointToDist2(0, 0, mo.momx, mo.momy), rmomz)
    local dist = (mospeed/freq)
    for i = dist, 1, -1 do
        local spawnedmo = P_SpawnMobjFromMobj(mo, (mo.momx/dist)*i, (mo.momy/dist)*i, (rmomz/dist)*i, trailmo)
        spawnedmo.color = SKINCOLOR_RED
        spawnedmo.blendmode = AST_ADD
		spawnedmo.frame = FF_TRANS50
		spawnedmo.fuse = 8
		spawnedmo.destscale = 0
    end
end

addHook("MobjThinker", function(mo)
	if not (mo.target and mo.target.valid) return end
	local z
	if mo.eflags & MFE_VERTICALFLIP
		z = mo.target.z-mo.target.height/2
	else
		z = mo.target.z
	end
	if mo.type == MT_LIGHTBURST
		P_TeleportMove(mo, mo.target.x, mo.target.y, z)
	else
		P_TeleportMove(mo, mo.target.x+P_ReturnThrustX(mo, mo.target.player.drawangle, mo.target.scale*3*-1), mo.target.y+P_ReturnThrustY(mo, mo.target.player.drawangle, mo.target.scale*3*-1), mo.target.z)
	end
	mo.rollangle = mo.target.rollangle
	mo.angle = mo.target.player.drawangle
end, MT_LIGHTBURST)

addHook("MobjThinker", function(mo)
	if not (mo.target and mo.target.valid) return end
	local z
	if mo.eflags & MFE_VERTICALFLIP
		z = mo.target.z-mo.target.height/2
	else
		z = mo.target.z
	end
	if mo.type == MT_SCARFPRIORITY
		P_TeleportMove(mo, mo.target.x, mo.target.y, z)
	else
		P_TeleportMove(mo, mo.target.x+P_ReturnThrustX(mo, mo.target.player.drawangle, mo.target.scale*3*-1), mo.target.y+P_ReturnThrustY(mo, mo.target.player.drawangle, mo.target.scale*3*-1), mo.target.z)
	end
	mo.rollangle = mo.target.rollangle
	mo.angle = mo.target.player.drawangle
	mo.scale = mo.target.scale
end, MT_SCARFPRIORITY)

addHook("MobjDeath", function(mo)
	if mo and mo.valid
		return true
	end
end, MT_LIGHTBURST)

addHook("MobjThinker", function(mo)
	if mo and mo.valid
		mo.shadowscale = 0
		if mo.target and mo.target.player
			if mo.target.player.playerstate == PST_DEAD
			or P_PlayerInPain(mo.target.player)
			or (CBW_Battle and (mo.target.player.tumble != nil and mo.target.player.tumble > 0)) //Tumble Fix
			or mo.target.player.state == S_PLAY_DEAD
			or mo.target.player.state == S_PLAY_DRWN
			or mo.target.player.state == S_PLAY_PAIN //xd
			or mo.target.player.state == S_PLAY_STUN //Why not?
				P_RemoveMobj(mo)
			end
		end
	end
end, MT_LIGHTBURST)

local cv_friendlyfire = CV_FindVar("friendlyfire")

addHook("TouchSpecial", function(special, mo)
	if special and special.valid and special.health
		if mo and mo.valid and mo.player
		and mo.player.playerstate == PST_LIVE
			if special.target != mo //Don't Kill Yourself
				if not G_CoopGametype()
					if not P_PlayerInPain(mo.player)
					and not mo.player.powers[pw_invulnerability]
					and not mo.player.powers[pw_flashing]
						S_StartSound(mo, sfx_buzz2)
						local particle = P_SpawnMobjFromMobj(mo, 0, 0, 0, MT_THOK)
						particle.target = mo
						if particle and particle.valid
							particle.state = S_LIGHTBURST_PARTICLE
							particle.fuse = 8
						end
					end
					P_DamageMobj(mo, special.target, special.target)
				else
					if cv_friendlyfire.value >= 1
						if not P_PlayerInPain(mo.player)
						and not mo.player.powers[pw_invulnerability]
						and not mo.player.powers[pw_flashing]
							S_StartSound(mo, sfx_buzz2)
							local particle = P_SpawnMobjFromMobj(mo, 0, 0, 0, MT_THOK)
							particle.target = mo
							if particle and particle.valid
								particle.state = S_LIGHTBURST_PARTICLE
								particle.fuse = 8
							end
						end
						P_DamageMobj(mo, special.target, special.target)
					end
				end
			end
		end
	end
	return true
end, MT_LIGHTBURST)

addHook("MobjCollide", function(special, mo)
	if special and special.valid and special.health
		if mo and mo.valid and mo.health
			if mo.flags & MF_ENEMY
			or mo.flags & MF_BOSS
			or mo.flags & MF_MONITOR
				if not (special.z > mo.z+mo.height)
				and not (mo.z > special.z+special.height)
					if not (mo.flags2 & MF2_FRET)
						S_StartSound(mo, sfx_buzz2)
						local particle = P_SpawnMobjFromMobj(mo, 0, 0, 0, MT_THOK)
						particle.target = mo
						if particle and particle.valid
							particle.state = S_LIGHTBURST_PARTICLE
							particle.fuse = 8
						end
					end
					P_DamageMobj(mo, special, special.target)
				end
			end
		end
	end
end, MT_LIGHTBURST)

addHook("MobjMoveCollide", function(special, mo)
	if special and special.valid and special.health
		if mo and mo.valid and mo.health
			if mo.flags & MF_ENEMY
			or mo.flags & MF_BOSS
			or mo.flags & MF_MONITOR
				if not (special.z > mo.z+mo.height)
				and not (mo.z > special.z+special.height)
					if not (mo.flags2 & MF2_FRET)
						S_StartSound(mo, sfx_buzz2)
						local particle = P_SpawnMobjFromMobj(mo, 0, 0, 0, MT_THOK)
						particle.target = mo
						if particle and particle.valid
							particle.state = S_LIGHTBURST_PARTICLE
							particle.fuse = 8
						end
					end
					P_DamageMobj(mo, special, special.target)
				end
			end
		end
	end
end, MT_LIGHTBURST)

addHook("MobjThinker", function(mo)
	if mo and mo.valid
	and mo.type == MT_SCARFSHOT
		local angplasma = leveltime*ANG10
		local angplasma2 = leveltime*(ANG1*27)
		local scarfshot_speed = FixedHypot(mo.momx, mo.momy)
		mo.rollangle = $ + FixedMul(FixedDiv(scarfshot_speed, mo.scale), ANG1/2)
		local plasmaparticle = P_SpawnMobjFromMobj(mo, P_RandomRange(-10, 10) * FRACUNIT, P_RandomRange(-10, 10) * FRACUNIT, P_RandomRange(0, 20) * FRACUNIT, MT_FIREBALLTRAIL)
		plasmaparticle.color = SKINCOLOR_SKY
		plasmaparticle.colorized = true
		plasmaparticle.scale = 1*FRACUNIT/2
		plasmaparticle.destscale = 1*FRACUNIT/4
		plasmaparticle.momz = 2*FRACUNIT
		local plasmaparticle2 = P_SpawnMobjFromMobj(mo, P_RandomRange(-10, 10) * FRACUNIT, P_RandomRange(-10, 10) * FRACUNIT, P_RandomRange(0, 20) * FRACUNIT, MT_PUMATRAIL)
		plasmaparticle2.color = SKINCOLOR_CYAN
		plasmaparticle2.colorized = true
		plasmaparticle2.scale = 1*FRACUNIT/2
		plasmaparticle2.destscale = 1*FRACUNIT/4
		plasmaparticle2.momz = 2*FRACUNIT
		mo.color = SKINCOLOR_CYAN
		mo.colorized = true
		mo.blendmode = AST_ADD
		local scarfspark = P_SpawnMobjFromMobj(mo,P_RandomRange(-6, 6)*FRACUNIT,P_RandomRange(-6, 6)*FRACUNIT,P_RandomRange(0, 12)*FRACUNIT, MT_THOK)
		scarfspark.state = S_NIGHTSPARKLE1
		scarfspark.angle = mo.angle + ANGLE_90
		scarfspark.color = SKINCOLOR_CYAN
		scarfspark.blendmode = AST_ADD
		scarfspark.colorized = true
		scarfspark.fuse = 6
		scarfspark.destscale = 0
		local elecspark = P_SpawnMobjFromMobj(mo,
		P_RandomRange(-6, 6)*FRACUNIT,
		P_RandomRange(-6, 6)*FRACUNIT,
		P_RandomRange(0, 12)*FRACUNIT, MT_THOK)
		elecspark.state = S_SCARFSHOK
		elecspark.angle = mo.angle + ANGLE_90
		elecspark.color = SKINCOLOR_CYAN
		elecspark.blendmode = AST_ADD
		elecspark.colorized = true
		elecspark.fuse = 8
		elecspark.destscale = 0
		local plasmaspark = P_SpawnMobjFromMobj(mo,
		P_RandomRange(-6, 6)*FRACUNIT,
		P_RandomRange(-6, 6)*FRACUNIT,
		P_RandomRange(0, 12)*FRACUNIT, MT_THOK)
		local plasmashot = P_SpawnMobj(
		mo.x+FixedMul(-35*mo.scale, cos(angplasma)),
		mo.y+FixedMul(-35*mo.scale, sin(angplasma)),
		mo.z+mo.height/2,
		MT_SCARFTHOK)
		local plasmashot2 = P_SpawnMobj(
		mo.x+FixedMul(35*mo.scale, cos(angplasma)),
		mo.y+FixedMul(35*mo.scale, sin(angplasma)),
		mo.z+mo.height/2,
		MT_SCARFTHOK)
		plasmaspark.state = S_SCARF_ARMA_PARTICLES
		plasmaspark.target = mo
		plasmaspark.angle = mo.angle + ANGLE_90
		plasmaspark.color = mo.color
		plasmaspark.colorized = true
		plasmaspark.blendmode = AST_ADD
		plasmaspark.fuse = 8
		plasmaspark.destscale = 0
		plasmashot.scale = mo.scale/2
		plasmashot.blendmode = AST_ADD
		plasmashot.frame = A|FF_FULLBRIGHT|TR_TRANS50
		plasmashot.color = P_RandomRange(SKINCOLOR_CYAN, SKINCOLOR_SKY, SKINCOLOR_SAPPHIRE)
		plasmashot.fuse = 1
		plasmashot.colorized = true
		plasmashot2.scale = mo.scale/2
		plasmashot2.blendmode = AST_ADD
		plasmashot2.frame = A|FF_FULLBRIGHT|TR_TRANS50
		plasmashot2.color = P_RandomRange(SKINCOLOR_CYAN, SKINCOLOR_SKY, SKINCOLOR_SAPPHIRE)
		plasmashot2.colorized = true
		plasmashot2.fuse = 1
		plasmashot.sprite = SPR_SCAF
		plasmashot2.sprite = SPR_SCAF
	end
end, MT_SCARFSHOT)

local function ScarfJump(player)
	local mo = player.mo
	if player.powers[pw_carry]
		return
	end
	if player.speed >= FixedMul(mo.scale,player.runspeed)
		if (player.mo.swordstate or player.mo.scarfplasma == 1)
			if player.mo.state != S_SCARF_SWORD1
			or player.mo.state != S_SCARF_SWORD2
			or player.mo.state != S_SCARF_SWORD3
			or player.mo.state != S_SCARF_SWORD4
			or player.mo.state != S_SCARF_SWORD5
			or player.mo.state != S_SCARF_SWORD6
			or player.mo.state != S_SCARF_SWORD7
				player.mo.state = S_SCARF_SWORD1
			end
		else
			mo.state = S_PLAY_GLIDE
		end
	else
		if (player.mo.swordstate or player.mo.scarfplasma == 1)
			if player.mo.state != S_SCARF_SWORD1
			or player.mo.state != S_SCARF_SWORD2
			or player.mo.state != S_SCARF_SWORD3
			or player.mo.state != S_SCARF_SWORD4
			or player.mo.state != S_SCARF_SWORD5
			or player.mo.state != S_SCARF_SWORD6
			or player.mo.state != S_SCARF_SWORD7
				player.mo.state = S_SCARF_SWORD1
			end
		else
			mo.state = P_MobjFlip(mo)*mo.momz > 0 and S_PLAY_SPRING or S_PLAY_FALL
		end
	end
end

addHook("MobjThinker", function(mo)
    if mo and mo.valid
        if not mo.source return end
        mo.lifetime = $ or 0
        P_TeleportMove(mo, mo.source.x + mo.lifetime * mo.momx, mo.source.y + mo.lifetime * mo.momy, mo.source.z + 17*FRACUNIT + mo.lifetime * mo.momz)
        mo.lifetime = $ + 1
    end
end, MT_SCARFARMAELECTICPARTICLE)

addHook("MobjThinker", function(mo)
    if not mo.source return end
    mo.lifetime = $ or 0
    P_TeleportMove(mo, mo.source.x + mo.lifetime * mo.momx, mo.source.y + mo.lifetime * mo.momy, mo.source.z + 17*FRACUNIT + mo.lifetime * mo.momz)
    mo.lifetime = $ + 1
end, MT_SCARFARMAELECTICPARTICLE)

addHook("MobjThinker", function(mo)
    if mo and mo.valid
        if not mo.source return end
        mo.lifetime = $ or 0
        P_TeleportMove(mo, mo.source.x + mo.lifetime * mo.momx, mo.source.y + mo.lifetime * mo.momy, mo.source.z + 17*FRACUNIT + mo.lifetime * mo.momz)
        mo.lifetime = $ + 1
    end
end, MT_SCARFARMAELECTICPARTICLE)

addHook("MobjThinker", function(mo)
    if not mo.source return end
    mo.lifetime = $ or 0
    P_TeleportMove(mo, mo.source.x + mo.lifetime * mo.momx, mo.source.y + mo.lifetime * mo.momy, mo.source.z + 17*FRACUNIT + mo.lifetime * mo.momz)
    mo.lifetime = $ + 1
end, MT_SCARFARMAELECTICPARTICLE)

addHook("MobjThinker", function(mo)
	if mo and mo.valid
	and mo.type == MT_SCARFTHOK
		local scarfthok_speed = FixedHypot(mo.momx, mo.momy)
		mo.rollangle = $ + FixedMul(FixedDiv(scarfthok_speed, mo.scale), ANG1/2)
		local scarfthokghost = P_SpawnGhostMobj(mo)
		scarfthokghost.fuse = 7
		scarfthokghost.destscale = 0
		local scarfthokghost2 = P_SpawnGhostMobj(mo)
		scarfthokghost2.fuse = 9
		scarfthokghost2.destscale = 0
		scarfthokghost2.frame = FF_TRANS60
		local scarfthokghost3 = P_SpawnGhostMobj(mo)
		scarfthokghost3.fuse = 4
		scarfthokghost3.destscale = 0
		scarfthokghost3.frame = FF_TRANS70
		for player in players.iterate
			if (player.mo and player.mo.valid and player.mo.skin == "scarf")
				local cv_chasecam = CV_FindVar("chasecam")
				local cv_chasecam2 = CV_FindVar("chasecam2")
				if ((player == displayplayer) and not cv_chasecam.value) or ((player == secondarydisplayplayer) and not cv_chasecam2.value)
					scarfthokghost.flags2 = $|MF2_DONTDRAW
					scarfthokghost2.flags2 = $|MF2_DONTDRAW
					scarfthokghost3.flags2 = $|MF2_DONTDRAW
				end
			end
		end
	end
end, MT_SCARFTHOK)

addHook("ThinkFrame", do
	for player in players.iterate
		if (player.mo and player.mo.valid and player.mo.skin == "scarf")
		and not player.exiting
			local cv_chasecam = CV_FindVar("chasecam")
			local cv_chasecam2 = CV_FindVar("chasecam2")
			if player.powers[pw_carry]
			or P_PlayerInPain(player)
			or player.exiting
			or player.playerstate == PST_DEAD
				if player.mo.swordstate > 1
					player.mo.swordstate = 0
				end
				if player.mo.swordmah
				and player.mo.swordmah.valid
					P_RemoveMobj(player.mo.swordmah)
					player.mo.swordmah = nil
				end
			end
			if player.playerstate == PST_DEAD
				player.charability = CA_NONE
			end
			//Arma Form Function
			if player.armaform
			and not player.powers[pw_super]
			and not player.powers[pw_extralife]
			and not (player.exiting)
			//Arma Form Activated
				player.armaform = false
			end
			if (player.gotflag or player.gotcrystal)
				player.mo.sworddash = 0
				player.mo.swordjump = 0
			end
			if player.rings >= 150
			and ((player.mo.state == S_PLAY_SUPER_TRANS1) or (player.mo.state == S_PLAY_SUPER_TRANS2))
			and not player.armaform
			and player.powers[pw_super]
				player.armaform = true
				P_Earthquake(player.mo, player.mo, 256*FRACUNIT)
				P_StartQuake(79*FRACUNIT, 3)
				P_FlashPal(player, PAL_WHITE, 3)
				P_NukeEnemies(player.mo, player.mo, RING_DIST)
			end
			//Speed in a 55 fracunit
			if player.speed >= player.runspeed
			and (player.speed > 55*FRACUNIT)
			and player.playerstate == PST_LIVE
			and not player.powers[pw_carry]
				SpeedRun(player)
				if leveltime % (TICRATE+TICRATE/2) == 4
					S_StartSound(player.mo, sfx_whlspd)
				end
			end
			if player.speed >= player.runspeed
			and (player.speed < 55*FRACUNIT)
				S_StopSoundByID(player.mo, sfx_whlspd)
			end
			if not (player.mo.sworddash)
				player.mo.sworddash = 0
			end
			if player.mo.sworddash > 0
				player.mo.sworddash = $1 - 1
			end
			if (player.pflags & PF_SHIELDABILITY)
				player.pflags = $1 & ~PF_JUMPED
			end
			//Jump
			if (player.pflags & PF_JUMPED)
			and not (player.pflags & PF_THOKKED)
			and not P_IsObjectOnGround(player.mo)
			and player.playerstate == PST_LIVE
			and not (player.mo.state == S_SCARF_SWORD1
			or player.mo.state == S_SCARF_SWORD2
			or player.mo.state == S_SCARF_SWORD3
			or player.mo.state == S_SCARF_SWORD4
			or player.mo.state == S_SCARF_SWORD5
			or player.mo.state == S_SCARF_SWORD6
			or player.mo.state == S_SCARF_SWORD7)
				ScarfJump(player)
			end
			//Float/Hover Dash
			if player.mo.sworddash > 1
			and not P_PlayerInPain(player)
			and not (P_IsObjectOnGround(player.mo))
			and player.playerstate == PST_LIVE
			and not (player.powers[pw_justsprung] or (player.mo.eflags & MFE_SPRUNG))
			and not player.powers[pw_carry]
				player.mo.momz = 0
				player.pflags = $1 & ~PF_SPINDOWN
				player.pflags = $1 & ~PF_STARTDASH
				player.pflags = $1 & ~PF_SPINNING
				player.mo.state = S_PLAY_GLIDE
				player.drawangle = player.mo.angle
				local aura = P_SpawnMobjFromMobj(player.realmo, P_RandomRange(-18, 18) * FRACUNIT, P_RandomRange(-18, 18) * FRACUNIT, P_RandomRange(0, 32) * FRACUNIT, MT_FLAMEPARTICLE)
				aura.color = SKINCOLOR_RED
				aura.colorized = true
				aura.blendmode = AST_ADD
				local electric = P_SpawnMobjFromMobj(player.realmo, P_RandomRange(-18, 18) * FRACUNIT, P_RandomRange(-18, 18) * FRACUNIT, P_RandomRange(0, 32) * FRACUNIT, MT_FLAMEPARTICLE)
				electric.color = SKINCOLOR_RED
				electric.colorized = true
				electric.blendmode = AST_ADD
				electric.state = S_WATERZAP
				local boostdash = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z, MT_THOK)
				boostdash.color = P_RandomRange(SKINCOLOR_RED, SKINCOLOR_KETCHUP)
				boostdash.colorized = true
				boostdash.blendmode = AST_ADD
				boostdash.sprite = SPR_FIRS
				boostdash.frame = S|FF_TRANS50
				boostdash.angle = player.mo.angle
				boostdash.fuse = 1
				if player.mo.eflags & MFE_VERTICALFLIP
					boostdash.eflags = $|MFE_VERTICALFLIP
					P_TeleportMove(boostdash, boostdash.x, boostdash.y, boostdash.z - FixedMul(12*FRACUNIT, player.mo.scale))
				end
				if not CBW_Battle
					if not player.powers[pw_super]
					and not player.powers[pw_sneakers]
					and not (player.mo.eflags & MFE_UNDERWATER)
						P_InstaThrust(player.mo, player.mo.angle, 60*FRACUNIT)
					elseif player.powers[pw_super]
					and not (player.mo.eflags & MFE_UNDERWATER)
						P_InstaThrust(player.mo, player.mo.angle, 80*FRACUNIT)
					elseif player.powers[pw_super]
					and (player.mo.eflags & MFE_UNDERWATER)
						P_InstaThrust(player.mo, player.mo.angle, 80*FRACUNIT/2)
					elseif player.powers[pw_sneakers]
					and not (player.mo.eflags & MFE_UNDERWATER)
						P_InstaThrust(player.mo, player.mo.angle, 80*FRACUNIT)
					elseif player.powers[pw_sneakers]
					and (player.mo.eflags & MFE_UNDERWATER)
						P_InstaThrust(player.mo, player.mo.angle, 80*FRACUNIT/2)
					elseif not player.powers[pw_super]
					and not player.powers[pw_sneakers]
					and (player.mo.eflags & MFE_UNDERWATER)
						P_InstaThrust(player.mo, player.mo.angle, 60*FRACUNIT/2)
					end
				else
					if (player.mo.eflags & MFE_UNDERWATER)
						if player.powers[pw_sneakers]
							P_InstaThrust(player.mo, player.mo.angle, 36*FRACUNIT)
						else
							P_InstaThrust(player.mo, player.mo.angle, 24*FRACUNIT)
						end
					else
						if player.powers[pw_sneakers]
							P_InstaThrust(player.mo, player.mo.angle, 60*FRACUNIT)
						else
							P_InstaThrust(player.mo, player.mo.angle, 45*FRACUNIT)
						end
					end
				end
				if player == displayplayer and not splitscreen
					P_StartQuake(FRACUNIT, 3)
				end
				if ((player == displayplayer) and not cv_chasecam.value) or ((player == secondarydisplayplayer) and not cv_chasecam2.value)
					aura.flags2 = $|MF2_DONTDRAW
					electric.flags2 = $|MF2_DONTDRAW
				end
			end
			if not (player.mo.swordstate)
				player.mo.swordstate = 0
			end
			if player.mo.swordstate > 0
				player.mo.swordstate = $1 - 1
			end
			if player.mo.sworddash > 1
			and not P_PlayerInPain(player)
			and (P_IsObjectOnGround(player.mo))
			and player.playerstate == PST_LIVE
			and not (player.powers[pw_justsprung] or (player.mo.eflags & MFE_SPRUNG))
			and not player.powers[pw_carry]
				player.mo.sworddash = 0
				player.mo.state = S_PLAY_WALK
			end
			//Sword
			if player.mo.swordstate > 1
			and player.playerstate == PST_LIVE
			and not P_PlayerInPain(player)
			and not player.powers[pw_carry]
				player.charflags = $|SF_CANBUSTWALLS
				player.mo.scarfplasma = 0
				player.pflags = $1 & ~PF_SPINNING
				player.pflags = $1 & ~PF_SPINDOWN
				player.pflags = $1 & ~PF_STARTDASH
				if player.powers[pw_justsprung]
				or (player.mo.eflags & MFE_SPRUNG)
					player.mo.momz = $*5/4
					player.mo.momx = $*5/4
					player.mo.momy = $*5/4
					player.mo.swordstate = 0
					player.weapondelay = 10
					S_StartSound(player.mo, sfx_sprong)
					local swordghost = P_SpawnGhostMobj(player.mo) 
					if swordghost and swordghost.valid
						swordghost.color = SKINCOLOR_RED
						swordghost.colorized = true
						swordghost.destscale = $ * 2
						swordghost.blendmode = AST_ADD
						swordghost.target = player.mo
					end
					if (P_IsObjectOnGround(player.mo))
						player.mo.state = S_PLAY_WALK
					end
					if player.mo.swordmah and player.mo.swordmah.valid then
						P_KillMobj(player.mo.swordmah)
						player.mo.swordmah = nil
					end
				end
				P_SPMAngle(player.mo, MT_SWORDDAMAGE, player.drawangle, 0)
			end
			if player.powers[pw_justsprung]
			or (player.mo.eflags & MFE_SPRUNG)
				if player.armaform == true
					player.pflags = $1|PF_JUMPED
				end
			end
			if player.powers[pw_justsprung]
			or (player.mo.eflags & MFE_SPRUNG)
			or player.powers[pw_carry]
				player.mo.sworddash = 0
				player.mo.swordjump = 0
				player.mo.scarfdodge = 1
				player.mo.rollangle = 0
			end
			if (player.mo.state == S_PLAY_SPRING)
			and (player.mo.state == S_PLAY_FALL)
				player.mo.sworddash = 0
				player.mo.swordjump = 0
			end
			if not (player.mo.usedown)
				player.mo.usedown = 0
			end
			if not (player.mo.custom2down)
				player.mo.custom2down = 0
			end
			if not (player.mo.swordjump)
				player.mo.swordjump = 0
			end
			if player.mo.swordjump > 0
				player.mo.swordjump = $1 - 1
			end
			//Sprite Swords
			if player.mo.swordstate > 1
			and player.playerstate == PST_LIVE
				if player.mo.swordmah
					if player.mo.swordmah.valid
						local swordmah = player.mo.swordmah
						local angle = R_PointToAngle2(swordmah.x, swordmah.y, player.mo.x+player.mo.momx+FixedMul(cos(player.drawangle), player.mo.radius*2), player.mo.y+player.mo.momy+FixedMul(sin(player.drawangle), player.mo.radius*2))
						local dist = R_PointToDist2(swordmah.x, swordmah.y, player.mo.x+player.mo.momx+FixedMul(cos(player.drawangle), player.mo.radius*2), player.mo.y+player.mo.momy+FixedMul(sin(player.drawangle), player.mo.radius*2))
						swordmah.angle = player.drawangle
						swordmah.scale = player.mo.scale+FRACUNIT/4
						swordmah.flags2 = $|MF2_SPLAT
						swordmah.renderflags = $1|RF_NOSPLATBILLBOARD
						swordmah.momz = 0
						P_InstaThrust(swordmah, angle, dist)
						if player.mo.eflags & MFE_VERTICALFLIP
							swordmah.z = player.mo.z+player.mo.height*1
						else
							swordmah.z = player.mo.z+player.mo.height/4
						end
						if ((player == displayplayer) and not cv_chasecam.value) or ((player == secondarydisplayplayer) and not cv_chasecam2.value)
							swordmah.flags2 = $|MF2_DONTDRAW
						end
					end
				end
			end
			//Arma Particles Part 1
			if player.powers[pw_super] and player.armaform == true
				local sparkle2 = P_SpawnMobjFromMobj(player.mo, P_RandomRange(-10, 10) * FRACUNIT, P_RandomRange(-10, 10) * FRACUNIT, 20*FRACUNIT + 15*FRACUNIT, MT_SCARFARMAELECTICPARTICLE)
				sparkle2.momx = P_RandomRange(-5, 5) * FRACUNIT
				sparkle2.momy = P_RandomRange(-5, 5) * FRACUNIT
				sparkle2.momz =  P_RandomRange(-5, 5) * FRACUNIT
				sparkle2.color = SKINCOLOR_KETCHUP
				sparkle2.colorized = true
				sparkle2.blendmode = AST_ADD
				sparkle2.scale = player.mo.scale/3*2
				sparkle2.source = player.mo
				if ((player == displayplayer) and not cv_chasecam.value) or ((player == secondarydisplayplayer) and not cv_chasecam2.value)
					sparkle2.flags2 = $|MF2_DONTDRAW
				end
			end
			if player.mo.swordstate == 1
			or (player.powers[pw_justsprung] or (player.mo.eflags & MFE_SPRUNG))
			or player.playerstate == PST_DEAD
			or not player.mo.state == S_SCARF_SWORD1
			or P_PlayerInPain(player)
			or player.mo.state == S_PLAY_STUN 
			or player.mo.state == S_PLAY_DEAD 
			or player.mo.state == S_PLAY_DRWN
			or player.mo.sprite == SPR2_TRNS
			or not player.mo.skin == "scarf" //Swap
				player.charflags = $ & ~SF_CANBUSTWALLS
				if player.mo.swordmah and player.mo.swordmah.valid then
					P_KillMobj(player.mo.swordmah)
					player.mo.swordmah = nil
				end
				if player.armaform == true
					player.pflags = $1|PF_JUMPED
				end
				if (player.cmd.buttons & BT_USE)
				and not CBW_Battle
					player.mo.scarfplasma = 5
				elseif not (player.cmd.buttons & BT_USE)
				or P_PlayerInPain(player)
					player.mo.scarfplasma = 0
				end
			end
			if (player.mo.state == S_PLAY_SUPER_TRANS1
			or player.mo.state == S_PLAY_SUPER_TRANS2
			or player.mo.state == S_PLAY_SUPER_TRANS3
			or player.mo.state == S_PLAY_SUPER_TRANS4
			or player.mo.state == S_PLAY_SUPER_TRANS5
			or player.mo.state == S_PLAY_SUPER_TRANS6)
				player.mo.swordstate = 0
				if player.mo.swordmah and player.mo.swordmah.valid then
					P_KillMobj(player.mo.swordmah)
					player.mo.swordmah = nil
				end
			end
			if player.mo.swordstate == 1
			and player.playerstate == PST_LIVE
			and not player.powers[pw_carry]
				if (P_IsObjectOnGround(player.mo))
					player.mo.state = S_PLAY_WALK
				end
			end
			if (player.mo.eflags & MFE_JUSTHITFLOOR)
			and (player.mo.eflags & MFE_ONGROUND)
			and not (player.mo.eflags & MFE_SPRUNG)
			and not (player.mo.flags & FF_EXISTS) 
			and not (player.mo.flags & FF_STRONGBUST) 
			and not (player.mo.flags & FF_BUSTUP)
			and not player.powers[pw_justlaunched]
			and not P_PlayerInPain(player)
			and player.playerstate == PST_LIVE
			and (player.mo.swordstate or player.mo.scarfplasma == 1)
				player.mo.state = S_SCARF_SWORD1
				if (player.mo.state >= S_SCARF_SWORD1 and player.mo.state <= S_SCARF_SWORD7)
					player.mo.frame = (player.mo.state-S_SCARF_SWORD1)|($1 & !FF_FRAMEMASK)
				elseif (player.mo.state >= S_SCARF_SWORD1 and player.mo.state <= S_SCARF_SWORD3)
					player.mo.frame = (player.mo.state-S_SCARF_SWORD1)|($1 & !FF_FRAMEMASK)
				elseif (player.mo.state >= S_SCARF_SWORD4 and player.mo.state <= S_SCARF_SWORD6)
					player.mo.frame = ((player.mo.state-S_SCARF_SWORD4)+7)|($1 & !FF_FRAMEMASK)
				end
			end
			//Sword Jump
			if player.mo.swordjump > 1
			and not P_PlayerInPain(player)
			and not (P_IsObjectOnGround(player.mo))
			and not (player.powers[pw_justsprung] or (player.mo.eflags & MFE_SPRUNG))
			and player.playerstate == PST_LIVE
			and not player.powers[pw_carry]
				player.pflags = $1 & ~PF_JUMPED
				player.pflags = $1 & ~PF_THOKKED
				local aura2 = P_SpawnMobjFromMobj(player.realmo, P_RandomRange(-18, 18) * FRACUNIT, P_RandomRange(-18, 18) * FRACUNIT, P_RandomRange(0, 32) * FRACUNIT, MT_FLAMEPARTICLE)
				aura2.color = SKINCOLOR_RED
				aura2.colorized = true
				aura2.blendmode = AST_ADD
				local electric3 = P_SpawnMobjFromMobj(player.realmo, P_RandomRange(-18, 18) * FRACUNIT, P_RandomRange(-18, 18) * FRACUNIT, P_RandomRange(0, 32) * FRACUNIT, MT_FLAMEPARTICLE)
				electric3.color = SKINCOLOR_RED
				electric3.colorized = true
				electric3.blendmode = AST_ADD
				electric3.state = S_WATERZAP
				if (player.mo.eflags & MFE_UNDERWATER)
					P_SetObjectMomZ(player.mo, 15*FRACUNIT/2, false)
				else
					P_SetObjectMomZ(player.mo, 15*FRACUNIT, false)
				end
				if ((player == displayplayer) and not cv_chasecam.value) or ((player == secondarydisplayplayer) and not cv_chasecam2.value)
					electric3.flags2 = $|MF2_DONTDRAW
				end
				local scarf_aura_jump = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z, MT_THOK)
				scarf_aura_jump.sprite = SPR_SCLL
				scarf_aura_jump.frame = A|FF_TRANS50
				scarf_aura_jump.fuse = 1
				scarf_aura_jump.color = P_RandomRange(SKINCOLOR_RED, SKINCOLOR_KETCHUP)
				scarf_aura_jump.colorized = true
				scarf_aura_jump.blendmode = AST_ADD
				if player.mo.eflags & MFE_VERTICALFLIP
					scarf_aura_jump.eflags = $|MFE_VERTICALFLIP
					P_TeleportMove(scarf_aura_jump, scarf_aura_jump.x, scarf_aura_jump.y, scarf_aura_jump.z - FixedMul(12*FRACUNIT, player.mo.scale))
				end
			end
			if player.mo.swordjump > 1
				player.mo.sworddash = 0
			end
			if player.mo.swordjump > 1
			and not P_PlayerInPain(player)
			and (P_IsObjectOnGround(player.mo))
			and not (player.powers[pw_justsprung] or (player.mo.eflags & MFE_SPRUNG))
			and player.playerstate == PST_LIVE
			and not player.powers[pw_carry]
				player.mo.swordjump = 0
				player.mo.state = S_PLAY_WALK
			end
			//Night Special
			if (player.powers[pw_carry] == CR_NIGHTSMODE)
				local nightfireparticle = P_SpawnMobj(player.mo.x+P_RandomRange(-10,10)*FRACUNIT,player.mo.y+P_RandomRange(-10,10)*FRACUNIT,player.mo.z+player.mo.height-15*FRACUNIT+P_RandomRange(-10,10)*FRACUNIT, MT_FLAMEPARTICLE)
				nightfireparticle.fuse = 7
				nightfireparticle.color = SKINCOLOR_RED
				nightfireparticle.colorized = true
				nightfireparticle.scale = player.mo.scale/2
				nightfireparticle.blendmode = AST_ADD
				if (leveltime & 3) == 1
					local ghostnight = P_SpawnGhostMobj(player.mo)
					ghostnight.color = SKINCOLOR_RED
					ghostnight.colorized = true
					ghostnight.blendmode = AST_ADD
					ghostnight.destscale = $ * 2
				end
			end
			if not (player.mo.scarfplasma)
				player.mo.scarfplasma = 0
			end
			if player.mo.scarfplasma > 0
				player.mo.scarfplasma = $1 - 1
			end
			if not (player.mo.scarfplasma2)
				player.mo.scarfplasma2 = 0
			end
			if player.mo.scarfplasma2 > 0
				player.mo.scarfplasma2 = $1 - 1
			end
			if player.mo.scarfplasma > 1
			and player.playerstate == PST_LIVE
			and (player.cmd.buttons & BT_USE)
			and not player.powers[pw_carry]
			and not P_PlayerInPain(player)
				player.mo.scarfplasma = 5
				if (leveltime & 3) == 1
				or player.mo.tics % 2
					local scarfplasma_shield = P_SpawnMobjFromMobj(player.mo,
					P_RandomRange(-20, 20)*FRACUNIT,
					P_RandomRange(-20, 20)*FRACUNIT,
					P_RandomRange(0, 50)*FRACUNIT, MT_FIREBALLTRAIL)
					scarfplasma_shield.color = SKINCOLOR_CYAN
					scarfplasma_shield.colorized = true
					scarfplasma_shield.blendmode = AST_ADD
					scarfplasma_shield.fuse = 8
					scarfplasma_shield.momz = 2
					scarfplasma_shield.scale = 1*FRACUNIT/2
					scarfplasma_shield.destscale = 1*FRACUNIT/4
					local scarfplasma_shield2 = P_SpawnMobjFromMobj(player.mo,
					P_RandomRange(-20, 20)*FRACUNIT,
					P_RandomRange(-20, 20)*FRACUNIT,
					P_RandomRange(0, 50)*FRACUNIT,MT_PUMATRAIL)
					scarfplasma_shield2.color = SKINCOLOR_SKY
					scarfplasma_shield2.colorized = true
					scarfplasma_shield2.blendmode = AST_ADD
					scarfplasma_shield2.fuse = 6
					scarfplasma_shield2.momz = 4
					scarfplasma_shield2.scale = 1*FRACUNIT/2
					scarfplasma_shield2.destscale = 1*FRACUNIT/4
					if ((player == displayplayer) and not cv_chasecam.value) or ((player == secondarydisplayplayer) and not cv_chasecam2.value)
						scarfplasma_shield.flags2 = $|MF2_DONTDRAW
						scarfplasma_shield2.flags2 = $|MF2_DONTDRAW
					end
				end
				if player.mo.colorized == false
					player.mo.color = SKINCOLOR_RED
					player.mo.colorized = true
				else
					player.mo.color = player.skincolor
					player.mo.colorized = false
				end
				local ang = leveltime*ANG10
				local ang2 = leveltime*ANG20
				local plasmascarfaurashield = P_SpawnMobj(
				player.mo.x+FixedMul(-40*player.mo.scale, cos(ang)),
				player.mo.y+FixedMul(-40*player.mo.scale, sin(ang)),
		 		player.mo.z+player.mo.height/2,
				MT_SCARFTHOK)
				local plasmascarfaurashield2 = P_SpawnMobj(
				player.mo.x+FixedMul(40*player.mo.scale, cos(ang)),
				player.mo.y+FixedMul(40*player.mo.scale, sin(ang)),
				player.mo.z+player.mo.height/2,
				MT_SCARFTHOK)
				plasmascarfaurashield.scale = player.mo.scale/3
				plasmascarfaurashield.blendmode = AST_ADD
				plasmascarfaurashield.frame = A|FF_FULLBRIGHT|TR_TRANS50
				plasmascarfaurashield.color = P_RandomRange(SKINCOLOR_CYAN, SKINCOLOR_SKY, SKINCOLOR_SAPPHIRE)
				plasmascarfaurashield.fuse = 1
				plasmascarfaurashield.colorized = true
				plasmascarfaurashield2.scale = player.mo.scale/3
				plasmascarfaurashield2.blendmode = AST_ADD
				plasmascarfaurashield2.frame = A|FF_FULLBRIGHT|TR_TRANS50
				plasmascarfaurashield2.color = P_RandomRange(SKINCOLOR_CYAN, SKINCOLOR_SKY, SKINCOLOR_SAPPHIRE)
				plasmascarfaurashield2.colorized = true
				plasmascarfaurashield2.fuse = 1
				local psasd = P_SpawnMobj(
				player.mo.x+FixedMul(-40*player.mo.scale, cos(ang2)),
				player.mo.y+FixedMul(-40*player.mo.scale, sin(ang2)),
		 		player.mo.z+player.mo.height/2,
				MT_SCARFTHOK)
				local psasd2 = P_SpawnMobj(
				player.mo.x+FixedMul(40*player.mo.scale, cos(ang2)),
				player.mo.y+FixedMul(40*player.mo.scale, sin(ang2)),
				player.mo.z+player.mo.height/2,
				MT_SCARFTHOK)
				psasd.scale = player.mo.scale/3
				psasd.blendmode = AST_ADD
				psasd.frame = A|FF_FULLBRIGHT|TR_TRANS50
				psasd.color = P_RandomRange(SKINCOLOR_CYAN, SKINCOLOR_SKY, SKINCOLOR_SAPPHIRE)
				psasd.fuse = 1
				psasd.angle = player.drawangle+ANGLE_90
				psasd.colorized = true
				psasd2.scale = player.mo.scale/3
				psasd2.blendmode = AST_ADD
				psasd2.angle = player.drawangle+ANGLE_90
				psasd2.frame = A|FF_FULLBRIGHT|TR_TRANS50
				psasd2.color = P_RandomRange(SKINCOLOR_CYAN, SKINCOLOR_SKY, SKINCOLOR_SAPPHIRE)
				psasd2.colorized = true
				psasd2.fuse = 1
				plasmascarfaurashield.sprite = SPR_SCAF
				plasmascarfaurashield2.sprite = SPR_SCAF
				psasd.sprite = SPR_SCAF
				psasd2.sprite = SPR_SCAF
				if player.mo.eflags & MFE_VERTICALFLIP
					plasmascarfaurashield.eflags = $|MFE_VERTICALFLIP
					plasmascarfaurashield2.eflags = $|MFE_VERTICALFLIP
					plasmascarfaurashield2.momz = player.mo.z+player.mo.height*2
					plasmascarfaurashield.momz = player.mo.z+player.mo.height*2
					psasd.eflags = $|MFE_VERTICALFLIP
					psasd2.eflags = $|MFE_VERTICALFLIP
					psasd2.momz = player.mo.z+player.mo.height*2
					psasd.momz = player.mo.z+player.mo.height*2
				end
				if ((player == displayplayer) and not cv_chasecam.value) or ((player == secondarydisplayplayer) and not cv_chasecam2.value)
					plasmascarfaurashield.flags2 = $|MF2_DONTDRAW
					plasmascarfaurashield2.flags2 = $|MF2_DONTDRAW
					psasd.flags2 = $|MF2_DONTDRAW
					psasd2.flags2 = $|MF2_DONTDRAW
				end
				//This is Samus
				local plasmaaura = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z+player.mo.height/2, MT_THOK)
				plasmaaura.scale = player.mo.scale/2
				plasmaaura.fuse = 1
				plasmaaura.tics = 12
				plasmaaura.blendmode = AST_ADD
				plasmaaura.sprite = SPR_OILF
				plasmaaura.color = SKINCOLOR_WHITE
				plasmaaura.colorized = true
				plasmaaura.angle = player.drawangle+ANGLE_90
				plasmaaura.frame = A|FF_FULLBRIGHT|TR_TRANS70
				plasmaaura.renderflags = $|RF_NOCOLORMAPS|RF_FULLBRIGHT			
				plasmaaura.flags = $|MF_SOLID|MF_NOCLIPTHING|MF_NOCLIP & ~MF_NOCLIP & ~MF_NOCLIPHEIGHT
				plasmaaura.radius = 1
				plasmaaura.height = 1
				plasmaaura.destscale = $*99
			end
			if player.mo.scarfplasma > 1
			and P_PlayerInPain(player)
			and player.playerstate == PST_LIVE
				player.mo.scarfplasma = 0
			end
			if player.mo.scarfplasma == 1
			and player.playerstate == PST_LIVE
			and not player.powers[pw_carry]
			and not P_PlayerInPain(player)
				player.mo.state = S_SCARF_SWORD1
				player.mo.sworddash = 0
				player.mo.swordjump = 0
				S_StartSound(player.mo, sfx_swordd)
				player.mo.scarfplasma2 = 10
				P_SPMAngle(player.mo, MT_SCARFSHOT, player.drawangle, 0)
				S_StartSound(player.mo, sfx_s3k7c)
				player.pflags = $1 & ~PF_SPINNING
				player.pflags = $1 & ~PF_THOKKED
				player.pflags = $1 & ~PF_JUMPED
				player.pflags = $1 & ~PF_SPINDOWN
				player.pflags = $1 & ~PF_STARTDASH
				if player.mo.colorized == true
					player.mo.color = player.skincolor
					player.mo.colorized = false
				end
				if player.powers[pw_super]
				and player.armaform == true
					local scarfshotplasma1 = P_SPMAngle(player.mo, MT_SCARFSHOT, player.drawangle-ANG2, 0)
					local scarfshotplasma2 = P_SPMAngle(player.mo, MT_SCARFSHOT, player.drawangle+ANG2, 0)
				end
			end
			if player.mo.scarfplasma2 == 10
			and player.playerstate == PST_LIVE
			and not player.powers[pw_carry]
				local nicelightnull = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z+player.mo.height/2, MT_THOK)
				nicelightnull.scale = player.mo.scale/2
				nicelightnull.fuse = 1
				nicelightnull.blendmode = AST_ADD
				nicelightnull.sprite = SPR_OILF
				nicelightnull.color = SKINCOLOR_WHITE
				nicelightnull.colorized = true
				nicelightnull.angle = player.drawangle+ANGLE_90
				nicelightnull.frame = A|FF_FULLBRIGHT|TR_TRANS70
				nicelightnull.renderflags = $|RF_NOCOLORMAPS|RF_FULLBRIGHT			
				nicelightnull.flags = $|MF_SOLID|MF_NOCLIPTHING|MF_NOCLIP & ~MF_NOCLIP & ~MF_NOCLIPHEIGHT
				nicelightnull.destscale = 0
			end
			if player.mo.scarfplasma2 == 9
			and player.playerstate == PST_LIVE
			and not player.powers[pw_carry]
				local nicelightnull = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z+player.mo.height/2, MT_THOK)
				nicelightnull.scale = player.mo.scale/3
				nicelightnull.fuse = 1
				nicelightnull.blendmode = AST_ADD
				nicelightnull.sprite = SPR_OILF
				nicelightnull.color = SKINCOLOR_WHITE
				nicelightnull.colorized = true
				nicelightnull.angle = player.drawangle+ANGLE_90
				nicelightnull.frame = A|FF_FULLBRIGHT|TR_TRANS70
				nicelightnull.renderflags = $|RF_NOCOLORMAPS|RF_FULLBRIGHT			
				nicelightnull.flags = $|MF_SOLID|MF_NOCLIPTHING|MF_NOCLIP & ~MF_NOCLIP & ~MF_NOCLIPHEIGHT
				nicelightnull.destscale = 0
			end
			if player.mo.scarfplasma2 == 8
			and player.playerstate == PST_LIVE
			and not player.powers[pw_carry]
				local nicelightnull = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z+player.mo.height/2, MT_THOK)
				nicelightnull.scale = player.mo.scale/4
				nicelightnull.fuse = 1
				nicelightnull.blendmode = AST_ADD
				nicelightnull.sprite = SPR_OILF
				nicelightnull.color = SKINCOLOR_WHITE
				nicelightnull.colorized = true
				nicelightnull.angle = player.drawangle+ANGLE_90
				nicelightnull.frame = A|FF_FULLBRIGHT|TR_TRANS70
				nicelightnull.renderflags = $|RF_NOCOLORMAPS|RF_FULLBRIGHT			
				nicelightnull.flags = $|MF_SOLID|MF_NOCLIPTHING|MF_NOCLIP & ~MF_NOCLIP & ~MF_NOCLIPHEIGHT
				nicelightnull.destscale = 0
			end
			if player.mo.scarfplasma2 == 7
			and player.playerstate == PST_LIVE
			and not player.powers[pw_carry]
				local nicelightnull = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z+player.mo.height/2, MT_THOK)
				nicelightnull.scale = player.mo.scale/4
				nicelightnull.fuse = 1
				nicelightnull.blendmode = AST_ADD
				nicelightnull.sprite = SPR_OILF
				nicelightnull.color = SKINCOLOR_WHITE
				nicelightnull.colorized = true
				nicelightnull.angle = player.drawangle+ANGLE_90
				nicelightnull.frame = A|FF_FULLBRIGHT|TR_TRANS80
				nicelightnull.renderflags = $|RF_NOCOLORMAPS|RF_FULLBRIGHT			
				nicelightnull.flags = $|MF_SOLID|MF_NOCLIPTHING|MF_NOCLIP & ~MF_NOCLIP & ~MF_NOCLIPHEIGHT
				nicelightnull.destscale = 0
			end
			if player.mo.scarfplasma2 == 6
			and player.playerstate == PST_LIVE
			and not player.powers[pw_carry]
				local nicelightnull = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z+player.mo.height/2, MT_THOK)
				nicelightnull.scale = player.mo.scale/5
				nicelightnull.fuse = 1
				nicelightnull.blendmode = AST_ADD
				nicelightnull.sprite = SPR_OILF
				nicelightnull.color = SKINCOLOR_WHITE
				nicelightnull.colorized = true
				nicelightnull.angle = player.drawangle+ANGLE_90
				nicelightnull.frame = A|FF_FULLBRIGHT|TR_TRANS80
				nicelightnull.renderflags = $|RF_NOCOLORMAPS|RF_FULLBRIGHT			
				nicelightnull.flags = $|MF_SOLID|MF_NOCLIPTHING|MF_NOCLIP & ~MF_NOCLIP & ~MF_NOCLIPHEIGHT
				nicelightnull.destscale = 0
			end
			if player.mo.scarfplasma2 == 5
			and player.playerstate == PST_LIVE
			and not player.powers[pw_carry]
				local nicelightnull = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z+player.mo.height/2, MT_THOK)
				nicelightnull.scale = player.mo.scale/6
				nicelightnull.fuse = 1
				nicelightnull.blendmode = AST_ADD
				nicelightnull.sprite = SPR_OILF
				nicelightnull.color = SKINCOLOR_WHITE
				nicelightnull.colorized = true
				nicelightnull.angle = player.drawangle+ANGLE_90
				nicelightnull.frame = A|FF_FULLBRIGHT|TR_TRANS80
				nicelightnull.renderflags = $|RF_NOCOLORMAPS|RF_FULLBRIGHT			
				nicelightnull.flags = $|MF_SOLID|MF_NOCLIPTHING|MF_NOCLIP & ~MF_NOCLIP & ~MF_NOCLIPHEIGHT
				nicelightnull.destscale = 0
			end
			if player.mo.scarfplasma2 == 4
			and player.playerstate == PST_LIVE
			and not player.powers[pw_carry]
				local nicelightnull = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z+player.mo.height/2, MT_THOK)
				nicelightnull.scale = player.mo.scale/6
				nicelightnull.fuse = 1
				nicelightnull.blendmode = AST_ADD
				nicelightnull.sprite = SPR_OILF
				nicelightnull.color = SKINCOLOR_WHITE
				nicelightnull.colorized = true
				nicelightnull.angle = player.drawangle+ANGLE_90
				nicelightnull.frame = A|FF_FULLBRIGHT|TR_TRANS90
				nicelightnull.renderflags = $|RF_NOCOLORMAPS|RF_FULLBRIGHT			
				nicelightnull.flags = $|MF_SOLID|MF_NOCLIPTHING|MF_NOCLIP & ~MF_NOCLIP & ~MF_NOCLIPHEIGHT
				nicelightnull.destscale = 0
			end
			if player.mo.scarfplasma2 == 3
			and player.playerstate == PST_LIVE
			and not player.powers[pw_carry]
				local nicelightnull = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z+player.mo.height/2, MT_THOK)
				nicelightnull.scale = player.mo.scale/7
				nicelightnull.fuse = 1
				nicelightnull.blendmode = AST_ADD
				nicelightnull.sprite = SPR_OILF
				nicelightnull.color = SKINCOLOR_WHITE
				nicelightnull.colorized = true
				nicelightnull.angle = player.drawangle+ANGLE_90
				nicelightnull.frame = A|FF_FULLBRIGHT|TR_TRANS90
				nicelightnull.renderflags = $|RF_NOCOLORMAPS|RF_FULLBRIGHT			
				nicelightnull.flags = $|MF_SOLID|MF_NOCLIPTHING|MF_NOCLIP & ~MF_NOCLIP & ~MF_NOCLIPHEIGHT
				nicelightnull.destscale = 0
			end
			if player.mo.scarfplasma2 == 2
			and player.playerstate == PST_LIVE
			and not player.powers[pw_carry]
				local nicelightnull = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z+player.mo.height/2, MT_THOK)
				nicelightnull.scale = player.mo.scale/8
				nicelightnull.fuse = 1
				nicelightnull.blendmode = AST_ADD
				nicelightnull.sprite = SPR_OILF
				nicelightnull.color = SKINCOLOR_WHITE
				nicelightnull.colorized = true
				nicelightnull.angle = player.drawangle+ANGLE_90
				nicelightnull.frame = A|FF_FULLBRIGHT|TR_TRANS90
				nicelightnull.renderflags = $|RF_NOCOLORMAPS|RF_FULLBRIGHT			
				nicelightnull.flags = $|MF_SOLID|MF_NOCLIPTHING|MF_NOCLIP & ~MF_NOCLIP & ~MF_NOCLIPHEIGHT
				nicelightnull.destscale = 0
			end
			if player.mo.scarfplasma2 == 1
			and player.playerstate == PST_LIVE
			and not player.powers[pw_carry]
				local nicelightnull = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z+player.mo.height/2, MT_THOK)
				nicelightnull.scale = player.mo.scale/9
				nicelightnull.fuse = 1
				nicelightnull.blendmode = AST_ADD
				nicelightnull.sprite = SPR_OILF
				nicelightnull.color = SKINCOLOR_WHITE
				nicelightnull.colorized = true
				nicelightnull.angle = player.drawangle+ANGLE_90
				nicelightnull.frame = A|FF_FULLBRIGHT|TR_TRANS90
				nicelightnull.renderflags = $|RF_NOCOLORMAPS|RF_FULLBRIGHT			
				nicelightnull.flags = $|MF_SOLID|MF_NOCLIPTHING|MF_NOCLIP & ~MF_NOCLIP & ~MF_NOCLIPHEIGHT
				nicelightnull.destscale = 0
			end
			if not player.mo.scarfplasma
			or player.powers[pw_carry]
			or not (player.cmd.buttons & BT_USE)
			or P_PlayerInPain(player)
				if player.mo.colorized == true
					player.mo.color = player.skincolor
					player.mo.colorized = false
				end
			end
			if player.mo.swordjump == 1
			and not P_PlayerInPain(player)
			and not (P_IsObjectOnGround(player.mo))
			and player.playerstate == PST_LIVE
			and not player.powers[pw_carry]
				local swordghoststate2 = P_SpawnGhostMobj(player.mo)
				swordghoststate2.color = SKINCOLOR_RED
				swordghoststate2.colorized = true
				swordghoststate2.blendmode = AST_ADD
				swordghoststate2.destscale = $ * 2
				player.mo.state = S_PLAY_GRAVITYJUMP_OVER
				S_StartSound(player.mo, sfx_cdwn)
			end
			//Shields
			if player.powers[pw_shield] & ~SH_FIREFLOWER == SH_ELEMENTAL
			or player.powers[pw_shield] & ~SH_FIREFLOWER == SH_FLAMEAURA
				if player.mo.swordstate > 1
				and (P_IsObjectOnGround(player.mo))
				and not player.powers[pw_super]
				and not CBW_Battle
					P_ElementalFire(player)
				end
			end
			if player.powers[pw_shield] & ~SH_FIREFLOWER == SH_ARMAGEDDON
			and not player.powers[pw_super]
			and not CBW_Battle
				if player.mo.swordjump == 1
				and not (P_IsObjectOnGround(player.mo))
					A_OldRingExplode(player.mo, MT_SONIC3KBOSSEXPLODE)
					P_BlackOw(player)
					P_StartQuake(20*FRACUNIT, 35, {0, 0, 0}, player.mo.radius)
					P_Earthquake(player.mo, player.mo, 256*FRACUNIT)
					P_StartQuake(79*FRACUNIT, 3)
					P_FlashPal(player, PAL_WHITE, 3)
					S_StartSound(player.mo, sfx_bkpoof)
					P_NukeEnemies(player.mo, player.mo, RING_DIST)
					S_StartSound(player.mo, sfx_bgxpld)
					player.mo.alreadyexploded = true
				end
			end
			if player.powers[pw_sneakers]
			and player.playerstate == PST_LIVE
			and not player.powers[pw_carry]
			and not player.mo.sworddash
			and not player.mo.swrodjump
			and not player.powers[pw_super]
				player.charflags = $1|SF_RUNONWATER
				local sneakersauraghost = SpeedSneakers(player.mo, 2)
				sneakersauraghost.scale = 1*FRACUNIT + 1*FRACUNIT/6
				if (leveltime % 10) == 8
					local sneakersparticle = P_SpawnGhostMobj(player.mo) 
					if sneakersparticle and sneakersparticle.valid
						sneakersparticle.color = SKINCOLOR_RED
						sneakersparticle.colorized = true
						sneakersparticle.destscale = $ * 2
						sneakersparticle.blendmode = AST_ADD
						sneakersparticle.target = player.mo
					end
				end
				if player.speed >= player.runspeed
					local speedsneakers_mode = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z, MT_THOK)
					speedsneakers_mode.color = P_RandomRange(SKINCOLOR_RED, SKINCOLOR_ORANGE, SKINCOLOR_YELLOW)
					speedsneakers_mode.colorized = true
					speedsneakers_mode.blendmode = AST_ADD
					speedsneakers_mode.sprite = SPR_FIRS
					speedsneakers_mode.frame = S|FF_TRANS50
					speedsneakers_mode.angle = player.mo.angle
					speedsneakers_mode.fuse = 1
					if player.mo.eflags & MFE_VERTICALFLIP
						speedsneakers_mode.eflags = $|MFE_VERTICALFLIP
						P_TeleportMove(speedsneakers_mode, speedsneakers_mode.x, speedsneakers_mode.y, speedsneakers_mode.z - FixedMul(12*FRACUNIT, player.mo.scale))
					end
				end
			else
				player.charflags = $ & ~SF_RUNONWATER
			end
			if player.powers[pw_invulnerability]
			and player.playerstate == PST_LIVE
			and not player.powers[pw_carry]
			and not player.powers[pw_super]
				local plasmaaura2 = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z+player.mo.height/2, MT_THOK)
				plasmaaura2.scale = player.mo.scale/2
				plasmaaura2.fuse = 1
				plasmaaura2.tics = 12
				plasmaaura2.blendmode = AST_ADD
				plasmaaura2.sprite = SPR_OILF
				plasmaaura2.color = SKINCOLOR_WHITE
				plasmaaura2.colorized = true
				plasmaaura2.angle = player.drawangle+ANGLE_90
				plasmaaura2.frame = A|FF_FULLBRIGHT|TR_TRANS70
				plasmaaura2.renderflags = $|RF_NOCOLORMAPS|RF_FULLBRIGHT			
				plasmaaura2.flags = $|MF_SOLID|MF_NOCLIPTHING|MF_NOCLIP & ~MF_NOCLIP & ~MF_NOCLIPHEIGHT
				plasmaaura2.radius = 1
				plasmaaura2.height = 1
				plasmaaura2.destscale = $*99
				player.mo.scarfplasma2 = 10
				local scarf_monitorpowers = SpeedSneakers(player.mo, 2)
				scarf_monitorpowers.scale = 1*FRACUNIT + 1*FRACUNIT/6
				scarf_monitorpowers.color = SKINCOLOR_PASTEL
				scarf_monitorpowers.colorized = true
				local scarf_monitorpowers2 = SpeedSneakers(player.mo, 2)
				scarf_monitorpowers2.scale = 1*FRACUNIT + 1*FRACUNIT/8
				scarf_monitorpowers2.color = SKINCOLOR_PASTEL
				scarf_monitorpowers2.colorized = true
				scarf_monitorpowers2.frame = FF_TRANS70
				if (leveltime % 10) == 8
					local monitorpowersparticle = P_SpawnGhostMobj(player.mo) 
					if monitorpowersparticle and monitorpowersparticle.valid
						monitorpowersparticle.color = SKINCOLOR_PASTEL
						monitorpowersparticle.colorized = true
						monitorpowersparticle.destscale = $ * 2
						monitorpowersparticle.blendmode = AST_ADD
						monitorpowersparticle.target = player.mo
					end
				end
				local invulnerabilitythok = P_SpawnMobjFromMobj(player.mo, P_RandomRange(10, -10) * FRACUNIT, P_RandomRange(10, -10) * FRACUNIT, 20*FRACUNIT + 15*FRACUNIT, MT_SCARFARMAELECTICPARTICLE)
				invulnerabilitythok.momx = P_RandomRange(5, -5) * FRACUNIT
				invulnerabilitythok.momy = P_RandomRange(5, -5) * FRACUNIT
				invulnerabilitythok.momz =  P_RandomRange(5, -5) * FRACUNIT
				invulnerabilitythok.color = P_RandomRange(SKINCOLOR_RED, SKINCOLOR_ORANGE, SKINCOLOR_YELLOW, SKINCOLOR_PASTEL, SKINCOLOR_WHITE, SKINCOLOR_BROWN, SKINCOLOR_KETCHUP, SKINCOLOR_ROSY)
				invulnerabilitythok.colorized = true
				invulnerabilitythok.blendmode = AST_ADD
				invulnerabilitythok.scale = player.mo.scale/2
				invulnerabilitythok.source = player.mo
				invulnerabilitythok.target = player.mo
				invulnerabilitythok.state = S_THOK
				invulnerabilitythok.destscale = 0
				local invulnerabilitythok2 = P_SpawnMobjFromMobj(player.mo, P_RandomRange(10, -10) * FRACUNIT, P_RandomRange(10, -10) * FRACUNIT, 20*FRACUNIT + 15*FRACUNIT, MT_SCARFARMAELECTICPARTICLE)
				invulnerabilitythok2.momx = P_RandomRange(7, -7) * FRACUNIT
				invulnerabilitythok2.momy = P_RandomRange(7, -7) * FRACUNIT
				invulnerabilitythok2.momz =  P_RandomRange(7, -7) * FRACUNIT
				invulnerabilitythok2.color = P_RandomRange(SKINCOLOR_SUPERSILVER1, SKINCOLOR_SUPERPURPLE3,SKINCOLOR_SUPERSKY2, SKINCOLOR_SUPERSKY4, SKINCOLOR_SUPERSKY5, SKINCOLOR_SUPERPERIDOT2)
				invulnerabilitythok2.colorized = true
				invulnerabilitythok2.blendmode = AST_ADD
				invulnerabilitythok2.scale = player.mo.scale/3
				invulnerabilitythok2.source = player.mo
				invulnerabilitythok2.target = player.mo
				invulnerabilitythok2.state = S_THOK
				invulnerabilitythok2.destscale = 0
			end
			if player.mo.windjump ~= nil and player.pflags & PF_JUMPED
				player.mo.windjump = $ + 1
			else
				player.mo.windjump = 0
			end
			if player.powers[pw_shield] & ~SH_FIREFLOWER == SH_WHIRLWIND
			and player.mo.windjump == 1
			and not player.powers[pw_super]
			and not CBW_Battle
				player.mo.momz = 4*$/3
			end
			//Air Walk
			if not (P_IsObjectOnGround(player.mo))
			and player.playerstate == PST_LIVE
			and (player.mo.state == S_PLAY_WALK or player.mo.state == S_PLAY_RUN or player.mo.state == S_PLAY_STND or player.mo.state == S_PLAY_WAIT)
			and not player.armaform
			and not player.powers[pw_carry]
				if player.powers[pw_justlaunched]
					player.mo.state = S_PLAY_SPRING
				else
					player.mo.state = S_PLAY_FALL
				end
			end
			if player.playerstate == PST_REBORN
				player.mo.rollangle = 0
			end
			//Air Walk in Arma Form
			if not (P_IsObjectOnGround(player.mo))
			and player.playerstate == PST_LIVE
			and (player.mo.state == S_PLAY_WALK or player.mo.state == S_PLAY_RUN or player.mo.state == S_PLAY_STND or player.mo.state == S_PLAY_WAIT)
			and player.powers[pw_super] and player.armaform == true
			and not player.powers[pw_carry]
				player.pflags = $1|PF_JUMPED|PF_NOJUMPDAMAGE
			end
			if not (player.mo.scarfdodge)
				player.mo.scarfdodge = 0
			end
			if player.mo.scarfdodge > 0
				player.mo.scarfdodge = $1 - 1
			end
			//Fixed music in Super and Arma form
			if player.powers[pw_super]
				player.powers[pw_invulnerability] = 0
				player.powers[pw_sneakers] = 0
			end
			if player.mo.scarfdodge > 1
			and player.playerstate == PST_LIVE
			and not (P_IsObjectOnGround(player.mo))
			and not P_PlayerInPain(player)
			and not player.powers[pw_carry]
				player.mo.scarfplasma = 0
				S_StopSoundByID(player.mo, sfx_skid)
				player.mo.momx = FixedMul($, FRACUNIT*97/100)
				player.mo.momy = FixedMul($, FRACUNIT*97/100)
				player.powers[pw_nocontrol] = 2
				player.mo.state = S_PLAY_FALL
				player.mo.scarfdodge = 5
				player.mo.rollangle = $+ANGLE_22h
				player.drawangle = player.mo.angle
				if (leveltime & 3) == 1
					local scarfdodge = P_SpawnGhostMobj(player.mo)
					scarfdodge.color = SKINCOLOR_RED
					scarfdodge.colorized = true
					scarfdodge.blendmode = AST_ADD
					scarfdodge.destscale = 0
					scarfdodge.scale = player.mo.scale
					scarfdodge.scalespeed = player.mo.scalespeed*2
				end
			end
			if player.mo.scarfdodge == 1
			or (P_IsObjectOnGround(player.mo))
			or P_PlayerInPain(player)
			or player.powers[pw_carry]
			and player.playerstate == PST_LIVE
				player.mo.scarfdodge = 0
				player.mo.rollangle = 0
			end
			if not (player.mo.scarfplasmabattle)
				player.mo.scarfplasmabattle = 0
			end
			if player.mo.scarfplasmabattle > 0
				player.mo.scarfplasmabattle = $1 - 1
			end
			if player.mo.scarfplasmabattle > 1
			and player.playerstate == PST_LIVE
			and not player.powers[pw_carry]
			and not P_PlayerInPain(player)
				player.mo.swordstate = 0
				player.mo.momx = 8*$/9
				player.mo.momy = 8*$/9
				player.mo.momz = 2*$/5
				player.mo.scarfdodge = 0
				player.mo.sworddash = 0
				player.mo.swordjump = 0
				player.drawangle = player.mo.angle
				player.mo.state = S_PLAY_SCARFSPINDASH
				player.pflags = $1 & ~PF_SPINNING
				player.pflags = $1 & ~PF_THOKKED
				player.pflags = $1 & ~PF_JUMPED
				player.pflags = $1 & ~PF_SPINDOWN
				player.pflags = $1 & ~PF_STARTDASH
				local sparkle3 = P_SpawnMobjFromMobj(player.mo, P_RandomRange(10, -10) * FRACUNIT, P_RandomRange(10, -10) * FRACUNIT, 20*FRACUNIT + 15*FRACUNIT, MT_SCARFARMAELECTICPARTICLE)
				sparkle3.momx = P_RandomRange(5, -5) * FRACUNIT
				sparkle3.momy = P_RandomRange(5, -5) * FRACUNIT
				sparkle3.momz =  P_RandomRange(5, -5) * FRACUNIT
				sparkle3.color = SKINCOLOR_CYAN
				sparkle3.colorized = true
				sparkle3.blendmode = AST_ADD
				sparkle3.scale = player.mo.scale/3*2
				sparkle3.source = player.mo
				if ((player == displayplayer) and not cv_chasecam.value) or ((player == secondarydisplayplayer) and not cv_chasecam2.value)
					sparkle3.flags2 = $|MF2_DONTDRAW
				end
				if (leveltime % 8 == 0)
					local redelectricaura = P_SpawnMobj(player.mo.x,player.mo.y,player.mo.z,MT_SCARFPRIORITY)
					if redelectricaura and redelectricaura.valid then
						redelectricaura.target = player.mo
						redelectricaura.state = S_REDSCARFAURA
						redelectricaura.scale = player.mo.scale
						redelectricaura.spriteyoffset = -16*FRACUNIT
						redelectricaura.frame = FF_ANIMATE
						redelectricaura.color = SKINCOLOR_CYAN
						redelectricaura.colorized = true
						redelectricaura.fuse = 0
						redelectricaura.blendmode = AST_ADD
						if player.mo.scarfplasmabattle == 1
							redelectricaura.state = S_NULL
						end
					end
				end
				local ang = leveltime*ANG10
				local ang2 = leveltime*ANG20
				local psasb = P_SpawnMobj(
				player.mo.x+FixedMul(-40*player.mo.scale, cos(ang)),
				player.mo.y+FixedMul(-40*player.mo.scale, sin(ang)),
		 		player.mo.z+player.mo.height/2,
				MT_SCARFTHOK)
				local psasb2 = P_SpawnMobj(
				player.mo.x+FixedMul(40*player.mo.scale, cos(ang)),
				player.mo.y+FixedMul(40*player.mo.scale, sin(ang)),
				player.mo.z+player.mo.height/2,
				MT_SCARFTHOK)
				psasb.scale = player.mo.scale/3
				psasb.blendmode = AST_ADD
				psasb.frame = A|FF_FULLBRIGHT|TR_TRANS50
				psasb.color = P_RandomRange(SKINCOLOR_CYAN, SKINCOLOR_SKY, SKINCOLOR_SAPPHIRE)
				psasb.fuse = 1
				psasb.colorized = true
				psasb2.scale = player.mo.scale/3
				psasb2.blendmode = AST_ADD
				psasb2.frame = A|FF_FULLBRIGHT|TR_TRANS50
				psasb2.color = P_RandomRange(SKINCOLOR_CYAN, SKINCOLOR_SKY, SKINCOLOR_SAPPHIRE)
				psasb2.colorized = true
				psasb2.fuse = 1
				local psasdb = P_SpawnMobj(
				player.mo.x+FixedMul(-40*player.mo.scale, cos(ang2)),
				player.mo.y+FixedMul(-40*player.mo.scale, sin(ang2)),
		 		player.mo.z+player.mo.height/2,
				MT_SCARFTHOK)
				local psasdb2 = P_SpawnMobj(
				player.mo.x+FixedMul(40*player.mo.scale, cos(ang2)),
				player.mo.y+FixedMul(40*player.mo.scale, sin(ang2)),
				player.mo.z+player.mo.height/2,
				MT_SCARFTHOK)
				psasdb.scale = player.mo.scale/3
				psasdb.blendmode = AST_ADD
				psasdb.frame = A|FF_FULLBRIGHT|TR_TRANS50
				psasdb.color = P_RandomRange(SKINCOLOR_CYAN, SKINCOLOR_SKY, SKINCOLOR_SAPPHIRE)
				psasdb.fuse = 1
				psasdb.angle = player.drawangle+ANGLE_90
				psasdb.colorized = true
				psasdb2.scale = player.mo.scale/3
				psasdb2.blendmode = AST_ADD
				psasdb2.angle = player.drawangle+ANGLE_90
				psasdb2.frame = A|FF_FULLBRIGHT|TR_TRANS50
				psasdb2.color = P_RandomRange(SKINCOLOR_CYAN, SKINCOLOR_SKY, SKINCOLOR_SAPPHIRE)
				psasdb2.colorized = true
				psasdb2.fuse = 1
				psasb.sprite = SPR_SCAF
				psasb2.sprite = SPR_SCAF
				psasdb.sprite = SPR_SCAF
				psasdb2.sprite = SPR_SCAF
				if player.mo.eflags & MFE_VERTICALFLIP
					psasb.eflags = $|MFE_VERTICALFLIP
					psasb2.eflags = $|MFE_VERTICALFLIP
					psasb2.momz = player.mo.z+player.mo.height*2
					psasb.momz = player.mo.z+player.mo.height*2
					psasdb.eflags = $|MFE_VERTICALFLIP
					psasdb2.eflags = $|MFE_VERTICALFLIP
					psasdb2.momz = player.mo.z+player.mo.height*2
					psasdb.momz = player.mo.z+player.mo.height*2
				end
				if ((player == displayplayer) and not cv_chasecam.value) or ((player == secondarydisplayplayer) and not cv_chasecam2.value)
					psasb.flags2 = $|MF2_DONTDRAW
					psasb2.flags2 = $|MF2_DONTDRAW
					psasdb.flags2 = $|MF2_DONTDRAW
					psasdb2.flags2 = $|MF2_DONTDRAW
				end
				if player.mo.swordmah and player.mo.swordmah.valid then
					P_KillMobj(player.mo.swordmah)
					player.mo.swordmah = nil
				end
				if player.powers[pw_justsprung]
				or (player.mo.eflags & MFE_SPRUNG)
				or player.powers[pw_carry]
				or P_PlayerInPain(player)
					player.mo.scarfplasmabattle = 0
				end
			end
			if player.mo.scarfplasmabattle > 1
			and player.playerstate == PST_LIVE
			and (P_IsObjectOnGround(player.mo))
				player.mo.scarfplasmabattle = 0
				player.mo.state = S_PLAY_WALK
			end
			if player.mo.scarfplasmabattle == 1
			and player.playerstate == PST_LIVE
			and not player.powers[pw_carry]
			and not P_PlayerInPain(player)
				player.pflags = $1 & ~PF_SPINNING
				player.pflags = $1 & ~PF_THOKKED
				player.pflags = $1 & ~PF_JUMPED
				player.pflags = $1 & ~PF_SPINDOWN
				player.pflags = $1 & ~PF_STARTDASH
				player.mo.state = S_SCARF_SWORD1
				S_StartSound(player.mo, sfx_swordd)
				S_StartSound(player.mo, sfx_s3k7c)
				P_SPMAngle(player.mo, MT_SCARFSHOT, player.drawangle, 0)
				local scarfshot1 = P_SPMAngle(player.mo, MT_SCARFSHOT, player.drawangle-ANG2, 0)
				local scarfshot2 = P_SPMAngle(player.mo, MT_SCARFSHOT, player.drawangle+ANG2, 0)
			end
			//Crumble a Floor/Fof
			for x=player.mo.x,player.mo.x+player.mo.radius*2,player.mo.radius*2
				for y=player.mo.y,player.mo.y+player.mo.radius*2,player.mo.radius*2
					local ss = R_PointInSubsector(x,y)
					for fof in ss.sector.ffloors()
						if (fof.flags & FF_BUSTUP) and (fof.flags & FF_EXISTS)
						and player.mo.swordstate
							if (player.mo.z+player.mo.momz==fof.topheight or player.mo.z+player.mo.height+player.mo.momz==fof.bottomheight or (player.mo.eflags & MFE_VERTICALFLIP and (player.mo.z+player.mo.momz==fof.bottomheight or player.mo.z-player.mo.height-player.mo.momz==fof.topheight)))
								EV_CrumbleChain(ss.sector, fof)
								S_StartSound(player.mo, sfx_s3k5f)
							end
						end
					end
				end
			end
			if (player.cmd.buttons & BT_JUMP)
			and not (P_IsObjectOnGround(player.mo))
			and player.playerstate == PST_LIVE
			and player.armaform == true
				P_SetObjectMomZ(player.mo, FRACUNIT*3/2, 1)
			end
			if player.powers[pw_super] and player.armaform == true
				player.charability = CA_NONE
			end
			//Arma Particles Part 2
			if player.powers[pw_super] and player.armaform == true
				if (leveltime & 3) == 1
				or player.mo.tics % 2
					local scarfarma = P_SpawnMobjFromMobj(player.mo,
					P_RandomRange(-20, 20)*FRACUNIT,
					P_RandomRange(-20, 20)*FRACUNIT,
					P_RandomRange(0, 50)*FRACUNIT, MT_THOK)
					scarfarma.state = S_SCARF_ARMA_PARTICLES
					scarfarma.color = SKINCOLOR_RED
					scarfarma.colorized = true
					scarfarma.fuse = 8
					scarfarma.destscale = 0
					scarfarma.momz = 2
					local scarfarma2 = P_SpawnMobjFromMobj(player.mo,
					P_RandomRange(-20, 20)*FRACUNIT,
					P_RandomRange(-20, 20)*FRACUNIT,
					P_RandomRange(0, 50)*FRACUNIT, MT_THOK)
					scarfarma2.state = S_SCARF_ARMA_PARTICLES
					scarfarma2.color = SKINCOLOR_RUBY
					scarfarma2.colorized = true
					scarfarma2.fuse = 6
					scarfarma2.destscale = 0
					scarfarma2.momz = 4
					if ((player == displayplayer) and not cv_chasecam.value) or ((player == secondarydisplayplayer) and not cv_chasecam2.value)
						scarfarma.flags2 = $|MF2_DONTDRAW
						scarfarma2.flags2 = $|MF2_DONTDRAW
					end
				end
			end
			if player.mo.sworddash == 1
			and not P_PlayerInPain(player)
			and not (P_IsObjectOnGround(player.mo))
			and player.playerstate == PST_LIVE
			and not player.powers[pw_carry]
				player.mo.state = S_PLAY_FALL
				player.pflags = $ & ~PF_DRILLING
				player.pflags = $ & ~PF_JUMPED
				S_StartSound(player.mo, sfx_skid)
				if not (player.mo.eflags & MFE_UNDERWATER)
					P_InstaThrust(player.mo, player.mo.angle, 25*FRACUNIT/2)
				elseif (player.mo.eflags & MFE_UNDERWATER)
					P_InstaThrust(player.mo, player.mo.angle, 25*FRACUNIT)
				end
			end
			//Dodge
			if (player.cmd.buttons & BT_CUSTOM2)
			and (player.cmd.forwardmove > 0 
			or player.cmd.forwardmove < 0
			or player.cmd.sidemove > 0
			or player.cmd.sidemove < 0)
			and not player.exiting
			and not player.powers[pw_carry]
			and not (player.pflags & PF_STASIS)
			and (player.mo.state == S_PLAY_STND or player.mo.state == S_PLAY_WAIT)
			and not (player.mo.tracer and player.mo.tracer.type == MT_TUBEWAYPOINT)
			and player.mo.custom2down == 0
			and not player.armaform
			and player.playerstate == PST_LIVE
			and (P_IsObjectOnGround(player.mo))
			and not CBW_Battle
				player.mo.custom2down = 1
				player.mo.scarfdodge = 5
				player.mo.scarfplasma = 0
				S_StartSound(player.mo, sfx_sfdge)
				if not (player.pflags & PF_ANALOGMODE)
					if (player.cmd.forwardmove > 0)
					and not (player.cmd.sidemove > 0)
					and not (player.cmd.sidemove < 0)
						if not (player.mo.eflags & MFE_UNDERWATER)
							P_InstaThrust(player.mo, player.mo.angle, FixedMul(40*FRACUNIT, player.mo.scale))
							P_SetObjectMomZ(player.mo, 6*FRACUNIT, false)
						else
							P_InstaThrust(player.mo, player.mo.angle, FixedMul(40*FRACUNIT/2, player.mo.scale))
							P_SetObjectMomZ(player.mo, 6*FRACUNIT/2, false)
						end
					end
					if (player.cmd.forwardmove < 0)
					and not (player.cmd.sidemove > 0)
					and not (player.cmd.sidemove < 0)
						if not (player.mo.eflags & MFE_UNDERWATER)
							P_InstaThrust(player.mo, player.mo.angle, FixedMul(-40*FRACUNIT, player.mo.scale))
							P_SetObjectMomZ(player.mo, 6*FRACUNIT, false)
						else
							P_InstaThrust(player.mo, player.mo.angle, FixedMul(-40*FRACUNIT/2, player.mo.scale))
							P_SetObjectMomZ(player.mo, 6*FRACUNIT/2, false)
						end
					end
					if (player.cmd.sidemove > 0)
					and not (player.cmd.forwardmove > 0)
					and not (player.cmd.forwardmove < 0)
						if not (player.mo.eflags & MFE_UNDERWATER)
							P_InstaThrust(player.mo, player.mo.angle + ANGLE_90, FixedMul(-40*FRACUNIT, player.mo.scale))
							P_SetObjectMomZ(player.mo, 6*FRACUNIT, false)
						else
							P_InstaThrust(player.mo, player.mo.angle + ANGLE_90, FixedMul(-40*FRACUNIT/2, player.mo.scale))
							P_SetObjectMomZ(player.mo, 6*FRACUNIT/2, false)
						end
					end
					if (player.cmd.sidemove < 0)
					and not (player.cmd.forwardmove > 0)
					and not (player.cmd.forwardmove < 0)
						if not (player.mo.eflags & MFE_UNDERWATER)
							P_InstaThrust(player.mo, player.mo.angle - ANGLE_90, FixedMul(-40*FRACUNIT, player.mo.scale))
							P_SetObjectMomZ(player.mo, 6*FRACUNIT, false)
						else
							P_InstaThrust(player.mo, player.mo.angle - ANGLE_90, FixedMul(-40*FRACUNIT/2, player.mo.scale))
							P_SetObjectMomZ(player.mo, 6*FRACUNIT/2, false)
						end
					end
				else
					if not (player.mo.eflags & MFE_UNDERWATER)
						P_InstaThrust(player.mo, player.mo.angle, FixedMul(40*FRACUNIT, player.mo.scale))
						P_SetObjectMomZ(player.mo, 6*FRACUNIT, false)
					else
						P_InstaThrust(player.mo, player.mo.angle, FixedMul(40*FRACUNIT/2, player.mo.scale))
						P_SetObjectMomZ(player.mo, 6*FRACUNIT/2, false)
					end
				end
			end
			//Max Speed
			if player.speed >= player.runspeed
			and (player.speed > 70*FRACUNIT)
			and player.playerstate == PST_LIVE
			and not player.powers[pw_carry]
				MaxSpeedRun(player)
			end
			//Super Particles Part 1
			if player.powers[pw_super]
			and not player.armaform
				local sparkle3 = P_SpawnMobjFromMobj(player.mo, P_RandomRange(-10, 10) * FRACUNIT, P_RandomRange(-10, 10) * FRACUNIT, 20*FRACUNIT + 15*FRACUNIT, MT_SCARFARMAELECTICPARTICLE)
				sparkle3.momx = P_RandomRange(-5, 5) * FRACUNIT
				sparkle3.momy = P_RandomRange(-5, 5) * FRACUNIT
				sparkle3.momz =  P_RandomRange(-5, 5) * FRACUNIT
				sparkle3.color = SKINCOLOR_KETCHUP
				sparkle3.colorized = true
				sparkle3.blendmode = AST_ADD
				sparkle3.scale = player.mo.scale/3*2
				sparkle3.source = player.mo
				if ((player == displayplayer) and not cv_chasecam.value) or ((player == secondarydisplayplayer) and not cv_chasecam2.value)
					sparkle3.flags2 = $|MF2_DONTDRAW
				end
				for i = 1, 5
					local thok = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z, MT_SCARFARMAELECTICPARTICLE)
					thok.fuse = 8
					thok.color = SKINCOLOR_KETCHUP
					thok.colorized = true
					thok.blendmode = AST_ADD
					thok.eflags = $ | (P_RandomKey(2)*MFE_VERTICALFLIP)
					thok.scale = P_RandomRange(1,4)*player.mo.scale/8
					thok.momx = P_RandomRange(-16, 16)*player.mo.scale
					thok.momy = P_RandomRange(-16, 16)*player.mo.scale
					if ((player == displayplayer) and not cv_chasecam.value) or ((player == secondarydisplayplayer) and not cv_chasecam2.value)
						thok.flags2 = $|MF2_DONTDRAW
					end
				end
			end
			if not (player.cmd.buttons & BT_USE)
				player.mo.usedown = 0
			end
			if not (player.cmd.buttons & BT_CUSTOM2)
			or not (P_IsObjectOnGround(player.mo))
				player.mo.custom2down = 0
			end
			//Super Particles Part 2
			if player.powers[pw_super]
				local aura = P_SpawnMobjFromMobj(player.realmo, P_RandomRange(-18, 18) * FRACUNIT, P_RandomRange(-18, 18) * FRACUNIT, P_RandomRange(0, 32) * FRACUNIT, MT_FLAMEPARTICLE)
				local aura2 = P_SpawnMobjFromMobj(player.realmo, P_RandomRange(-28, 28) * FRACUNIT, P_RandomRange(-28, 28) * FRACUNIT, P_RandomRange(0, 42) * FRACUNIT, MT_BOXSPARKLE)
				aura.color = SKINCOLOR_RED
				aura.colorized = true
				aura.blendmode = AST_ADD
				aura2.color = SKINCOLOR_PURPLE
				aura2.colorized = true
				aura2.blendmode = AST_ADD
				aura2.frame = TR_TRANS70
				if ((player == displayplayer) and not cv_chasecam.value) or ((player == secondarydisplayplayer) and not cv_chasecam2.value)
					aura.flags2 = $|MF2_DONTDRAW
					aura2.flags2 = $|MF2_DONTDRAW
				end
			end
			if not player.powers[pw_extralife]
			and not (player.exiting)
			and player.playerstate == PST_LIVE
				if player.powers[pw_super] and not player.armaform then
					S_ChangeMusic("vsscar",true,player)
				elseif player.powers[pw_super] and player.armaform == true then
					if (leveltime % 10)
						if (leveltime % 10) == 1
						or (leveltime % 10) == 8
							player.mo.color = SKINCOLOR_ARMASCARF2
						elseif (leveltime % 10) == 2
						or (leveltime % 10) == 7
							player.mo.color = SKINCOLOR_ARMASCARF3
						elseif (leveltime % 10) == 3
						or (leveltime % 10) == 6
							player.mo.color = SKINCOLOR_ARMASCARF4
						elseif (leveltime % 10) == 4
						or (leveltime % 10) == 5
							player.mo.color = SKINCOLOR_ARMASCARF5
						or (leveltime % 10) == 7
							player.mo.color = SKINCOLOR_SILVER
						elseif (leveltime % 10) == 9
							player.mo.color = SKINCOLOR_ARMASCARF1
						end
					else
						player.mo.color = SKINCOLOR_ARMASCARF1
					end
					S_ChangeMusic("hyprsr", true, player)
				else
					P_RestoreMusic(player)
				end
			end
			//BonusType Voice
			if mapheaderinfo[gamemap].bonustype == 1 then
				//Fix a Samus
				if not ((G_BuildMapName(mapnum) == "MAPTN") or (G_BuildMapName(mapnum) == "MAPTM"))
					if leveltime == 1
						S_StartSound(player.mo, sfx_scftpe)
					end
				end
			end
		end
		if (player.mo and player.mo.valid and player.mo.skin == "scarf")
		and not P_PlayerInPain(player)
			local cv_chasecam = CV_FindVar("chasecam")
			local cv_chasecam2 = CV_FindVar("chasecam2")
			if not (player.mo.lightburst)
				player.mo.lightburst = 0
			end
			if player.mo.lightburst > 0
				player.mo.lightburst = $1 - 1
			end
			//Light Burst
			if player.mo.lightburst > 1
			and player.playerstate == PST_LIVE
				player.powers[pw_nocontrol] = 2
				player.pflags = $|PF_FULLSTASIS
				local ang = leveltime*ANG10
				local ang2 = leveltime*ANG20
				local lbplaura = P_SpawnMobj(
				player.mo.x+FixedMul(-65*player.mo.scale, cos(ang)),
				player.mo.y+FixedMul(-65*player.mo.scale, sin(ang)),
		 		player.mo.z+player.mo.height/2,
				MT_SCARFTHOK)
				local lbplaura2 = P_SpawnMobj(
				player.mo.x+FixedMul(65*player.mo.scale, cos(ang)),
				player.mo.y+FixedMul(65*player.mo.scale, sin(ang)),
				player.mo.z+player.mo.height/2,
				MT_SCARFTHOK)
				lbplaura.scale = player.mo.scale/3
				lbplaura.blendmode = AST_ADD
				lbplaura.frame = A|FF_FULLBRIGHT|TR_TRANS50
				lbplaura.color = P_RandomRange(SKINCOLOR_CYAN, SKINCOLOR_SKY, SKINCOLOR_SAPPHIRE)
				lbplaura.fuse = 1
				lbplaura.colorized = true
				lbplaura2.scale = player.mo.scale/3
				lbplaura2.blendmode = AST_ADD
				lbplaura2.frame = A|FF_FULLBRIGHT|TR_TRANS50
				lbplaura2.color = P_RandomRange(SKINCOLOR_CYAN, SKINCOLOR_SKY, SKINCOLOR_SAPPHIRE)
				lbplaura2.colorized = true
				lbplaura2.fuse = 1
				local lbpb = P_SpawnMobj(
				player.mo.x+FixedMul(-60*player.mo.scale, cos(ang2)),
				player.mo.y+FixedMul(-60*player.mo.scale, sin(ang2)),
		 		player.mo.z+player.mo.height/2,
				MT_SCARFTHOK)
				local lbpb2 = P_SpawnMobj(
				player.mo.x+FixedMul(60*player.mo.scale, cos(ang2)),
				player.mo.y+FixedMul(60*player.mo.scale, sin(ang2)),
				player.mo.z+player.mo.height/2,
				MT_SCARFTHOK)
				lbpb.scale = player.mo.scale/3
				lbpb.blendmode = AST_ADD
				lbpb.frame = A|FF_FULLBRIGHT|TR_TRANS50
				lbpb.color = P_RandomRange(SKINCOLOR_CYAN, SKINCOLOR_SKY, SKINCOLOR_SAPPHIRE)
				lbpb.fuse = 1
				lbpb.angle = player.drawangle+ANGLE_90
				lbpb.colorized = true
				lbpb2.scale = player.mo.scale/3
				lbpb2.blendmode = AST_ADD
				lbpb2.angle = player.drawangle+ANGLE_90
				lbpb2.frame = A|FF_FULLBRIGHT|TR_TRANS50
				lbpb2.color = P_RandomRange(SKINCOLOR_CYAN, SKINCOLOR_SKY, SKINCOLOR_SAPPHIRE)
				lbpb2.colorized = true
				lbpb2.fuse = 1
				lbplaura.sprite = SPR_SCAF
				lbplaura2.sprite = SPR_SCAF
				lbpb.sprite = SPR_SCAF
				lbpb2.sprite = SPR_SCAF
				if player.mo.eflags & MFE_VERTICALFLIP
					lbplaura.eflags = $|MFE_VERTICALFLIP
					lbplaura2.eflags = $|MFE_VERTICALFLIP
					lbplaura2.momz = player.mo.z+player.mo.height*2
					lbplaura.momz = player.mo.z+player.mo.height*2
					lbpb.eflags = $|MFE_VERTICALFLIP
					lbpb2.eflags = $|MFE_VERTICALFLIP
					lbpb2.momz = player.mo.z+player.mo.height*2
					lbpb.momz = player.mo.z+player.mo.height*2
				end
				if ((player == displayplayer) and not cv_chasecam.value) or ((player == secondarydisplayplayer) and not cv_chasecam2.value)
					lbplaura.flags2 = $|MF2_DONTDRAW
					lbplaura2.flags2 = $|MF2_DONTDRAW
					lbpb.flags2 = $|MF2_DONTDRAW
					lbpb2.flags2 = $|MF2_DONTDRAW
				end
			end
			if player.mo.lightburst == 1
			and player.playerstate == PST_LIVE
				player.pflags = $1 & ~PF_FULLSTASIS
				if P_IsObjectOnGround(player.mo)
					player.mo.state = S_PLAY_WALK
				else
					player.mo.state = S_PLAY_FALL
				end
			end
			if P_PlayerInPain(player)
			or (CBW_Battle and (player.tumble != nil and player.tumble > 0)) //Tumble Fix
			or player.playerstate == PST_DEAD
				player.mo.lightburst = 0
			end
			if player.mo.state != S_PLAY_LIGHTBURST1
			and player.mo.state != S_PLAY_LIGHTBURST2
			and player.mo.state != S_PLAY_LIGHTBURST3
			and player.playerstate == PST_LIVE
				if player.mo.lightburst <= 31
				and player.mo.lightburst > 16
					player.mo.state = S_PLAY_LIGHTBURST1
					player.mo.tics = player.mo.lightburst-16
				elseif player.mo.lightburst <= 16
				and player.mo.lightburst > 11
					player.mo.state = S_PLAY_LIGHTBURST2
					player.mo.tics = player.mo.lightburst-5
				else
					if player.mo.lightburst > 1
						player.mo.state = S_PLAY_LIGHTBURST3
						player.mo.tics = player.mo.lightburst
					end
				end
			end
			if player.powers[pw_justsprung]
			or (player.mo.eflags & MFE_SPRUNG)
			or player.powers[pw_carry]
				player.mo.lightburst = 0
			end
		end
		//Samus Gun
		if (player.mo and player.mo.valid and player.mo.skin == "scarf")
		and not P_PlayerInPain(player)
		and not player.exiting
			if (skins["samus"] == nil) then 
				return 
			end
			//Ice Blaster
			if not (player.mo.iceblaster)
				player.mo.iceblaster = 0
			end
			if not (player.mo.iceblaster2)
				player.mo.iceblaster2 = 0
			end
			if player.mo.iceblaster2 > 0
				player.mo.iceblaster2 = $1 - 1
			end
			if player.mo.iceblaster == 10
				player.mo.iceblaster = 10
				player.mo.iceblaster2 = 0
			end
			if player.mo.iceblaster2 > 1
				player.mo.iceblaster2 = 5
				if (leveltime % 13) == 1
					player.mo.iceblaster = $1 + 1
				end
			end
			if player.mo.iceblaster < 0
				player.mo.iceblaster = 1
				player.mo.iceblaster2 = 5
			end
			if player.powers[pw_super]
				player.mo.iceblaster = 10
			end
			if player.mo.iceblaster == 0
				player.mo.iceblaster2 = 5
				if not S_SoundPlaying(player.mo,sfx_relrr)
					S_StartSound(player.mo, sfx_relrr)
				end
			end
			if (player.cmd.buttons & BT_ATTACK)
			and not (player.cmd.buttons & BT_FIRENORMAL)
			and player.playerstate == PST_LIVE
			and not player.powers[pw_carry]
			and not (player.pflags & PF_STASIS)
			and not (player.pflags & PF_STARTDASH)
			and not (player.mo.state == S_PLAY_SUPER_TRANS1)
			and not (player.mo.tracer and player.mo.tracer.type == MT_TUBEWAYPOINT)
			and not player.mo.iceblaster2
			and not (player.mo.state == S_SCARF_SWORD1
			or player.mo.state == S_SCARF_SWORD2
			or player.mo.state == S_SCARF_SWORD3
			or player.mo.state == S_SCARF_SWORD4
			or player.mo.state == S_SCARF_SWORD5
			or player.mo.state == S_SCARF_SWORD6
			or player.mo.state == S_SCARF_SWORD7)
			and not player.mo.swordstate
			and not player.mo.sworddash
			and not player.mo.swordjump
				if (leveltime % 16) == 1
					player.pflags = $1 & ~PF_SPINNING
					player.pflags = $1 & ~PF_THOKKED
					player.pflags = $1 & ~PF_JUMPED
					player.pflags = $1 & ~PF_SPINDOWN
					player.pflags = $1 & ~PF_STARTDASH
					S_StartSound(player.mo, sfx_fire)
					S_StartSound(player.mo, sfx_hellrv)
					S_StartSound(player.mo, sfx_icsh)
					P_Thrust(player.mo, player.mo.angle, FixedMul(-FRACUNIT, player.mo.scale))
					player.mo.iceblaster = $1 - 1
					if player.mo.iceblaster <= 3
						player.mo.state = S_SCARF_ORANGEBLASTER1
						P_SpawnPlayerMissile(player.mo, MT_PBSHOT, MF2_SCATTER)
					else
						player.mo.state = S_SCARF_ICEBLASTER1
						P_SpawnPlayerMissile(player.mo, MT_ICSHOT, MF2_SCATTER)
					end
				end
			end
			if (player.cmd.buttons & BT_FIRENORMAL)
			and not (player.cmd.buttons & BT_ATTACK)
			and player.playerstate == PST_LIVE
			and not player.powers[pw_carry]
			and not (player.pflags & PF_STASIS)
			and not (player.pflags & PF_STARTDASH)
			and not (player.mo.state == S_PLAY_SUPER_TRANS1)
			and not (player.mo.tracer and player.mo.tracer.type == MT_TUBEWAYPOINT)
			and not player.mo.iceblaster2
			and player.mo.iceblaster >= 2
			and not (player.mo.state == S_SCARF_SWORD1
			or player.mo.state == S_SCARF_SWORD2
			or player.mo.state == S_SCARF_SWORD3
			or player.mo.state == S_SCARF_SWORD4
			or player.mo.state == S_SCARF_SWORD5
			or player.mo.state == S_SCARF_SWORD6
			or player.mo.state == S_SCARF_SWORD7)
			and not player.mo.swordstate
			and not player.mo.sworddash
			and not player.mo.swordjump
				if (leveltime % 19) == 1
					player.pflags = $1 & ~PF_SPINNING
					player.pflags = $1 & ~PF_THOKKED
					player.pflags = $1 & ~PF_JUMPED
					player.pflags = $1 & ~PF_SPINDOWN
					player.pflags = $1 & ~PF_STARTDASH
					player.mo.iceblaster2 = 0
					S_StartSound(player.mo, sfx_fire)
					S_StartSound(player.mo, sfx_hellrv)
					S_StartSound(player.mo, sfx_hbsh)
					P_Thrust(player.mo, player.mo.angle, FixedMul(-FRACUNIT, player.mo.scale))
					player.mo.iceblaster = $1 - 2
					if player.mo.iceblaster <= 3
						player.mo.state = S_SCARF_ORANGEBLASTER1
						P_SpawnPlayerMissile(player.mo, MT_PBCHARGESHOT, MF2_SCATTER)
					else
						player.mo.state = S_SCARF_ICEBLASTER1
						P_SpawnPlayerMissile(player.mo,  MT_ICCHARGESHOT, MF2_SCATTER)
					end
				end
			end
			if (player.cmd.buttons & BT_FIRENORMAL)
			and (player.cmd.buttons & BT_ATTACK)
			and player.playerstate == PST_LIVE
			and not player.powers[pw_carry]
			and not (player.pflags & PF_STASIS)
			and not (player.pflags & PF_STARTDASH)
			and not (player.mo.state == S_PLAY_SUPER_TRANS1)
			and not (player.mo.tracer and player.mo.tracer.type == MT_TUBEWAYPOINT)
			and not player.mo.iceblaster2
			and not (player.mo.state == S_SCARF_SWORD1
			or player.mo.state == S_SCARF_SWORD2
			or player.mo.state == S_SCARF_SWORD3
			or player.mo.state == S_SCARF_SWORD4
			or player.mo.state == S_SCARF_SWORD5
			or player.mo.state == S_SCARF_SWORD6
			or player.mo.state == S_SCARF_SWORD7)
			and not player.mo.swordstate
			and not player.mo.sworddash
			and not player.mo.swordjump
				if (leveltime % 25) == 1
					if player.mo.iceblaster >= 5
						player.pflags = $1 & ~PF_SPINNING
						player.pflags = $1 & ~PF_THOKKED
						player.pflags = $1 & ~PF_JUMPED
						player.pflags = $1 & ~PF_SPINDOWN
						player.pflags = $1 & ~PF_STARTDASH
						player.mo.iceblaster2 = 0
						S_StartSound(player.mo, sfx_fire)
						S_StartSound(player.mo, sfx_cmcha)
						S_StartSound(player.mo, sfx_iccm2)
						P_Thrust(player.mo, player.mo.angle, FixedMul(-FRACUNIT, player.mo.scale))
						player.mo.iceblaster = $1 - 5
						player.mo.state = S_SCARF_ULTIMATEBLASTER1
						P_SpawnPlayerMissile(player.mo, MT_PLCHARGESHOT, MF2_SCATTER)
					else
						player.pflags = $1 & ~PF_SPINNING
						player.pflags = $1 & ~PF_THOKKED
						player.pflags = $1 & ~PF_JUMPED
						player.pflags = $1 & ~PF_SPINDOWN
						player.pflags = $1 & ~PF_STARTDASH
						player.mo.iceblaster2 = 0
						S_StartSound(player.mo, sfx_fire)
						S_StartSound(player.mo, sfx_cmcha)
						S_StartSound(player.mo, sfx_iccm2)
						P_Thrust(player.mo, player.mo.angle, FixedMul(-FRACUNIT, player.mo.scale))
						player.mo.iceblaster = $1 - 3
						player.mo.state = S_SCARF_ULTIMATEBLASTER1
						P_SpawnPlayerMissile(player.mo, MT_PLSHOT, MF2_SCATTER)
					end
				end
			end
			if G_RingSlingerGametype()
				player.weapondelay = 1
			end
		end
		//Samus end
	end
end)

addHook("PlayerSpawn", function(player)
	if player.mo and player.mo.skin == "scarf"
	and player.playerstate == PST_LIVE
		if (skins["samus"] == nil) then 
			return 
		end
		player.mo.iceblaster = 10
	end
end)

addHook("PostThinkFrame", function()
    for player in players.iterate
		if player.mo and player.mo.valid and player.mo.skin == "scarf"
		and player.playerstate == PST_LIVE
		and not player.powers[pw_carry]
		and not P_PlayerInPain(player)
		and not player.exiting
			if player.mo.sworddash > 1
			or (player.powers[pw_super] and player.armaform == true)
			or player.mo.scarfplasma > 1
				local ghost5 = P_SpawnGhostMobj(player.mo)
				ghost5.color = SKINCOLOR_RED
				ghost5.colorized = true
				ghost5.fuse = 1
				ghost5.blendmode = AST_ADD
				P_TeleportMove(ghost5, player.mo.x, player.mo.y, player.mo.z - 4*FRACUNIT)
				ghost5.frame = $|FF_ADD
				ghost5.scale = 1*FRACUNIT + 1*FRACUNIT/6
				if ghost5.tracer
					ghost5.tracer.fuse = ghost5.fuse
				end
			end
		end
	end
end)

addHook("SpinSpecial", function(player)
	if (player.mo and player.mo.valid and player.playerstate == PST_LIVE and player.mo.skin == "scarf")
		if player.exiting
		or player.powers[pw_carry]
		or (player.pflags & PF_STASIS)
		or (player.mo.state == S_PLAY_SUPER_TRANS1)
		or (player.mo.state == S_PLAY_SUPER_TRANS2)
		or (player.mo.state == S_PLAY_SUPER_TRANS3)
		or (player.mo.state == S_PLAY_SUPER_TRANS4)
		or (player.mo.state == S_PLAY_SUPER_TRANS5)
		or (player.mo.state == S_PLAY_SUPER_TRANS6)
		or player.mo.usedown == 1
		or player.weapondelay
		or P_PlayerInPain(player)
		and player.playerstate == PST_LIVE
			return
		end
		player.mo.usedown = 1
		player.mo.sworddash = 0
		player.mo.swordjump = 0
		S_StartSound(player.mo, sfx_swordd)
		player.mo.swordstate = 12
		player.pflags = $1 & ~PF_SPINNING
		player.pflags = $1 & ~PF_THOKKED
		player.pflags = $1 & ~PF_JUMPED
		player.pflags = $1 & ~PF_SPINDOWN
		player.pflags = $1 & ~PF_STARTDASH
		player.mo.state = S_SCARF_SWORD1
		if player.mo.swordmah == nil
		or not player.mo.swordmah.valid
			player.mo.swordmah = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_SWORDMAH)
		elseif player.mo.swordmah
		and player.mo.swordmah.valid
			P_RemoveMobj(player.mo.swordmah)
			player.mo.swordmah = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_SWORDMAH)
		end
		if CBW_Battle
			player.weapondelay = 20
		else
			player.weapondelay = 10
		end
	end
end)

addHook("JumpSpinSpecial", function(player)
	if (player.mo and player.mo.valid and player.playerstate == PST_LIVE and player.mo.skin == "scarf")
		if player.exiting
		or player.powers[pw_carry]
		or (player.pflags & PF_STASIS)
		or (player.mo.state == S_PLAY_SUPER_TRANS1)
		or (player.mo.state == S_PLAY_SUPER_TRANS2)
		or (player.mo.state == S_PLAY_SUPER_TRANS3)
		or (player.mo.state == S_PLAY_SUPER_TRANS4)
		or (player.mo.state == S_PLAY_SUPER_TRANS5)
		or (player.mo.state == S_PLAY_SUPER_TRANS6)
		or player.mo.usedown == 1
		or player.weapondelay
		or P_PlayerInPain(player)
		and player.playerstate == PST_LIVE
			return
		end
		player.mo.usedown = 1
		player.mo.sworddash = 0
		player.mo.swordjump = 0
		S_StartSound(player.mo, sfx_swordd)
		player.mo.swordstate = 12
		player.pflags = $1 & ~PF_SPINNING
		player.pflags = $1 & ~PF_THOKKED
		player.pflags = $1 & ~PF_JUMPED
		player.pflags = $1 & ~PF_SPINDOWN
		player.pflags = $1 & ~PF_STARTDASH
		player.mo.state = S_SCARF_SWORD1
		if player.mo.swordmah == nil
		or not player.mo.swordmah.valid
			player.mo.swordmah = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_SWORDMAH)
		elseif player.mo.swordmah
		and player.mo.swordmah.valid
			P_RemoveMobj(player.mo.swordmah)
			player.mo.swordmah = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_SWORDMAH)
		end
		if CBW_Battle
			player.weapondelay = 20
		else
			player.weapondelay = 10
		end
	end
end)

local function cupasoupbitch(player)
	if All7Emeralds(emeralds) and (player.rings > 49) and (player.mo and player.mo.valid and player.playerstate == PST_LIVE and player.mo.skin == "scarf") and not (player.powers[pw_super]) and not (player.pflags & PF_SPINNING) and not (player.powers[pw_carry]) and not (player.pflags & PF_THOKKED) and not (maptol & TOL_NIGHTS)
	and not (player.panim == PA_ABILITY) and not (player.panim == PA_ABILITY2) and not (player.panim == PA_PAIN) and not (player.panim == PA_ETC)
		return true
	else
		return false
	end
end

//Support a Samus mod
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
rawset(_G, "scarfSpawnDialogueList", {
    ["Greenflower"] = {
        [1] = {"The signal shows that there are", "new anomalies in this universe. Well.", "SCFH1", 0, "small", "small", "Let's take a look. What these anomalies are."},
        [2] = {"Hmm.", "This is suspicious weather. It must be the shenanigans of Dr. Robotnik.", "SCFH3", 0, "small", "small", "Or whatever Sonic called it. Egghead."},
        [3] = {"Eggman!", "And what are you up to. You're trying to sic me on cars again.", "SCFH5", 0, "small", "small", "Come on. GO FOR IT!"}
    },
    
    ["Techno Hill"] = {
        [1] = {"Bruh Egghead", "fell on one spot again. How many times will he be pissed off that", "SCFH1", 0, "small", "small", "I want the world to be at peace."},
        [2] = {"How annoying are these badniks....", "We should cut his fucking egghead head off.", "SCFH5", 0, "small", "small", "For him to be done with his badniks/robots."},
        [3] = {"О Oh. Hello Eggman!", "I'm gonna kick your ass. Eggs running from me.", "SCFH1", 0, "small", "small", ": )"}
    },
    
    ["Deep Sea"] = {
        [1] = {"Hmm. Deep Sea.", "It's a really good temple to keep secrets in these traps. If without badniks it's", "SCFH1", 0, "small", "small", "not a good idea. Well, let's see what you've got stashed away. Egghead."},
        [2] = {"Hm...", "The temple was not so rough. And now it looks like it's aged.", "SCFH1", 0, "small", "small", "We need to study these temples even further."},
        [3] = {"О Oh. Hello Again Eggman!", "It's time to get it over with.", "SCFH5", 0, "small", "small", ": )"},
		[4] = {"AAAAAAAAAAAAAAAAAA!", "...Where am I....What the fuck is the ship flying around. Looks like.", "SCFH2", 0, "small", "small", "Someone walked around here and rather became dead to Eggman."}
    },
	
	["Castle Eggman"] = {
        [1] = {"Hm... I found a Casstle for Eggman. Interesting.", "Why didn't he call himself Dr. Egg?", "SCFH1", 0, "small"},
        [2] = {"Interesting. When will he call himself Dr. Egghead? He's literally Egg.", "Oh, I wish he could hear me. His ass would be on fire.", "SCFH3", 0, "small", "small"},
        [3] = {"Hello Dr. Egghead! Or... Dr.Egg!", "Why don't I make you an egg?", "SCFH5", 0, "small", "small"}
    },
	
	["Arid Canyon"] = {
        [1] = {"Hmm. Desert.", "Smell the ^Cowbells Case.^", "SCFH1", 0, "small", "small", "I hope someone is alive here?"},
        [2] = {"Interesting premise. There's even a puzzle/headwash in here, too.", "О Oh. I remembered that rat with the huge tail and hat. I think he lives here.", "SCFH3", 0, "small", "small", "I think his name is Fang...or is it Hank?"},
        [3] = {"О Oh. hello Fang! Or... Hank", "Why are you attacking me?", "SCFH1", 0, "small", "small", "I haven't done anything to you. I am a peaceful man. I'm not for anybody."},
		[4] = {"AAAAAAAAAAAAAAAAAA!", "...Where am I....Again. AGAIN!", "SCFH2", 0, "small", "small", "Someone walked around here and rather became dead to Eggman."}
    },
	
	["Red Volcano"] = {
        [1] = {"Hmm. Red Volcano.", "It's a really good volcan...", "SCFH1", 0, "small", "small", "Well, let's see what you've got stashed away. Dr. Egg"}
    },
	
	["Egg Rock"] = {
        [1] = {"Okay. I'm already at the Dr. Egg base. He'll get a pill for calling these.", "Green marauders.", "SCFH1", 0, "small"},
        [2] = {"EGG!", "WHERE ARE YOU!??!?!", "SCFH5", 0, "small", "small", "You want to play hide-and-seek with me. Heh. Come on. Let's do it."}
    },
	
	["Black Core"] = {
        [1] = {"WHAT A!", "Oh no. Base Eggman's is it's already breaking down...", "SCFH2", 0, "small", "small", "gotta run....RUN!"},
        [2] = {"Oh hello Robo Sonic!", "Lets go a battle!", "SCFH4", 0, "small", "small", "Faker!"},
        [3] = {"THERE YOU ARE SWEET MY!", "Have you decided to get yourself an old toy?", "SCFH5", 0, "small", "small", "OK. Let's have some fun."}
    }
})
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

addHook("PlayerThink", function(player)
	if player.mo and player.mo.skin == "scarf"
		if not P_PlayerInPain(player)
		and not (P_IsObjectOnGround(player.mo))
		and player.playerstate == PST_LIVE
		and not (player.powers[pw_justsprung] or (player.mo.eflags & MFE_SPRUNG))
		and not player.powers[pw_carry]
		and not player.exiting
			if player.mo.sworddash
				scarffloat(player.mo, MT_THOK, 4*FRACUNIT)
			end
			if player.mo.swordjump
				scarffloat(player.mo, MT_THOK, 4*FRACUNIT)
			end
		end
		if not P_PlayerInPain(player)
		and player.playerstate == PST_LIVE
		and not player.powers[pw_carry]
		and not player.exiting
		and not player.mo.sworddash
		and not player.mo.swordjump
		and not player.powers[pw_super]
			if player.powers[pw_sneakers]
				if player.speed >= player.runspeed
					scarffloat(player.mo, MT_THOK, 4*FRACUNIT)
				end
			end
		end
		local player_skin = skins[player.mo.skin].name
		if player_skin == "scarf"
			if S_MusicName() == "VSBOSS"
				COM_BufInsertText(player, "tunes SRBOS")
			elseif S_MusicName() == "VSFANG"
				COM_BufInsertText(player, "tunes FFNG")
			elseif S_MusicName() == "VSMETL"
				COM_BufInsertText(player, "tunes MMTL")
			elseif S_MusicName() == "VSBRAK"
				COM_BufInsertText(player, "tunes MBRAK")
			end
		else
			if S_MusicName() == "SRBOS"
			or S_MusicName() == "MBRAK"
			or S_MusicName() == "MMTL"
			or S_MusicName() == "FFNG"
				COM_BufInsertText(player, "tunes -default")
			end
		end
	end
	//Support a Samus mod part 2
	//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	
	//Thx Speccy!
	for p in players.iterate
		if not (p.mo and p.mo.valid) then 
			return 
		end
		if (p.mo.skin ~= "scarf") then 
			return 
		end
		if (skins["samus"] == nil) then 
			return 
		end
		if (gametype ~= GT_COOP) then 
			return 
		end
		local dialogue = scarfSpawnDialogueList[mapheaderinfo[gamemap].lvlttl][mapheaderinfo[gamemap].actnum]
		local map = mapheaderinfo[gamemap]
		if map.lvlttl == "Greenflower" and map.actnum == 1 then
			if (leveltime == 70)
				p.mo.samusforcetext = true
				SamusDialogue(p.mo, dialogue[1], dialogue[2], dialogue[3], 2, 0, dialogue[4], dialogue[5], dialogue[6], dialogue[7])
			end
		elseif map.lvlttl == "Greenflower" and map.actnum == 2 then
			if (leveltime == 70)
				p.mo.samusforcetext = true
				SamusDialogue(p.mo, dialogue[1], dialogue[2], dialogue[3], 2, 0, dialogue[4], dialogue[5], dialogue[6], dialogue[7])
			end
		elseif map.lvlttl == "Greenflower" and map.actnum == 3 then
			if (leveltime == 70)
				p.mo.samusforcetext = true
				SamusDialogue(p.mo, dialogue[1], dialogue[2], dialogue[3], 2, 0, dialogue[4], dialogue[5], dialogue[6], dialogue[7])
			end
		end
		if map.lvlttl == "Techno Hill" and map.actnum == 1 then
			if (leveltime == 70)
				p.mo.samusforcetext = true
				SamusDialogue(p.mo, dialogue[1], dialogue[2], dialogue[3], 2, 0, dialogue[4], dialogue[5], dialogue[6], dialogue[7])
			end
		elseif map.lvlttl == "Techno Hill" and map.actnum == 2 then
			if (leveltime == 70)
				p.mo.samusforcetext = true
				SamusDialogue(p.mo, dialogue[1], dialogue[2], dialogue[3], 2, 0, dialogue[4], dialogue[5], dialogue[6], dialogue[7])
			end
		elseif map.lvlttl == "Techno Hill" and map.actnum == 3 then
			if (leveltime == 70)
				p.mo.samusforcetext = true
				SamusDialogue(p.mo, dialogue[1], dialogue[2], dialogue[3], 2, 0, dialogue[4], dialogue[5], dialogue[6], dialogue[7])
			end
		end
		if map.lvlttl == "Deep Sea" and map.actnum == 1 then
			if (leveltime == 70)
				p.mo.samusforcetext = true
				SamusDialogue(p.mo, dialogue[1], dialogue[2], dialogue[3], 2, 0, dialogue[4], dialogue[5], dialogue[6], dialogue[7])
			end
		elseif map.lvlttl == "Deep Sea" and map.actnum == 2 then
			if (leveltime == 70)
				p.mo.samusforcetext = true
				SamusDialogue(p.mo, dialogue[1], dialogue[2], dialogue[3], 2, 0, dialogue[4], dialogue[5], dialogue[6], dialogue[7])
			end
		elseif map.lvlttl == "Deep Sea" and map.actnum == 3 then
			if (leveltime == 70)
				p.mo.samusforcetext = true
				SamusDialogue(p.mo, dialogue[1], dialogue[2], dialogue[3], 2, 0, dialogue[4], dialogue[5], dialogue[6], dialogue[7])
			end
		elseif map.lvlttl == "Deep Sea" and map.actnum == 4 then 
			if (leveltime == 70)
				p.mo.samusforcetext = true
				SamusDialogue(p.mo, dialogue[1], dialogue[2], dialogue[3], 2, 0, dialogue[4], dialogue[5], dialogue[6], dialogue[7])
			end
		end
		if map.lvlttl == "Castle Eggman" and map.actnum == 1 then
			if (leveltime == 70)
				p.mo.samusforcetext = true
				SamusDialogue(p.mo, dialogue[1], dialogue[2], dialogue[3], 2, 0, dialogue[4], dialogue[5], dialogue[6], dialogue[7])
			end
		elseif map.lvlttl == "Castle Eggman" and map.actnum == 2 then
			if (leveltime == 70)
				p.mo.samusforcetext = true
				SamusDialogue(p.mo, dialogue[1], dialogue[2], dialogue[3], 2, 0, dialogue[4], dialogue[5], dialogue[6], dialogue[7])
			end
		elseif map.lvlttl == "Castle Eggman" and map.actnum == 3 then
			if (leveltime == 70)
				p.mo.samusforcetext = true
				SamusDialogue(p.mo, dialogue[1], dialogue[2], dialogue[3], 2, 0, dialogue[4], dialogue[5], dialogue[6], dialogue[7])
			end
		end
		if map.lvlttl == "Arid Canyon" and map.actnum == 1 then
			if (leveltime == 70)
				p.mo.samusforcetext = true
				SamusDialogue(p.mo, dialogue[1], dialogue[2], dialogue[3], 2, 0, dialogue[4], dialogue[5], dialogue[6], dialogue[7])
			end
		elseif map.lvlttl == "Arid Canyon" and map.actnum == 2 then
			if (leveltime == 70)
				p.mo.samusforcetext = true
				SamusDialogue(p.mo, dialogue[1], dialogue[2], dialogue[3], 2, 0, dialogue[4], dialogue[5], dialogue[6], dialogue[7])
			end
		elseif map.lvlttl == "Arid Canyon" and map.actnum == 3 then
			if (leveltime == 70)
				p.mo.samusforcetext = true
				SamusDialogue(p.mo, dialogue[1], dialogue[2], dialogue[3], 2, 0, dialogue[4], dialogue[5], dialogue[6], dialogue[7])
			end
		elseif map.lvlttl == "Arid Canyon" and map.actnum == 4 then
			if (leveltime == 70)
				p.mo.samusforcetext = true
				SamusDialogue(p.mo, dialogue[1], dialogue[2], dialogue[3], 2, 0, dialogue[4], dialogue[5], dialogue[6], dialogue[7])
			end
		end
		if map.lvlttl == "Red Volcano" and map.actnum == 1 then
			if (leveltime == 70)
				p.mo.samusforcetext = true
				SamusDialogue(p.mo, dialogue[1], dialogue[2], dialogue[3], 2, 0, dialogue[4], dialogue[5], dialogue[6], dialogue[7])
			end
		end
		if map.lvlttl == "Egg Rock" and map.actnum == 1 then
			if (leveltime == 70)
				p.mo.samusforcetext = true
				SamusDialogue(p.mo, dialogue[1], dialogue[2], dialogue[3], 2, 0, dialogue[4], dialogue[5], dialogue[6], dialogue[7])
			end
		elseif map.lvlttl == "Egg Rock" and map.actnum == 2 then
			if (leveltime == 70)
				p.mo.samusforcetext = true
				SamusDialogue(p.mo, dialogue[1], dialogue[2], dialogue[3], 2, 0, dialogue[4], dialogue[5], dialogue[6], dialogue[7])
			end
		end
		if map.lvlttl == "Black Core" and map.actnum == 1 then
			if (leveltime == 70)
				p.mo.samusforcetext = true
				SamusDialogue(p.mo, dialogue[1], dialogue[2], dialogue[3], 2, 0, dialogue[4], dialogue[5], dialogue[6], dialogue[7])
			end
		elseif map.lvlttl == "Black Core" and map.actnum == 2 then
			if (leveltime == 70)
				p.mo.samusforcetext = true
				SamusDialogue(p.mo, dialogue[1], dialogue[2], dialogue[3], 2, 0, dialogue[4], dialogue[5], dialogue[6], dialogue[7])
			end
		elseif map.lvlttl == "Black Core" and map.actnum == 3 then
			if (leveltime == 70)
				p.mo.samusforcetext = true
				SamusDialogue(p.mo, dialogue[1], dialogue[2], dialogue[3], 2, 0, dialogue[4], dialogue[5], dialogue[6], dialogue[7])
			end
		end
	end
end)

local function ScarfMetroidDamage(s,i,so)
	if s and s.valid
		if i and i.valid
			if i.type == MT_SCARFSHOT
			and s.state == S_MTRDFROZEN
				return
			end
			if i.type == MT_SWORDDAMAGE
			and s.state == S_MTRDFROZEN
				return
			end
		end
		if (so and so.valid and so.skin == "scarf")
		and so.swordstate > 1
			s.stuntroid = 35
		end
	end
end
addHook("MobjDamage", ScarfMetroidDamage, MT_METROID)

addHook("MobjDeath", function(s, i, so)
	if not (so and so.player)
		return true
	end
	s.deathanim = 70
	s.fuse = 70
	P_SpawnGhostMobj(s)	
	s.color = SKINCOLOR_RED
	s.colorized = true
	s.blendmode = AST_ADD
	if not (so and so.valid) then 
		return 
	end
	if (so.skin ~= "scarf") then 
		return 
	end
	if (skins["samus"] == nil) then 
		return 
	end
	if (gametype ~= GT_COOP) then 
		return 
	end
	so.samusforcetext = true
	SamusDialogue(so, ".......?", nil, "SCFH3", 2, 0, 105-17)
end, MT_METROIDLARVA)

addHook("MobjDeath", function(s, i, so)
	if not (so and so.player)
		return true
	end
	if not (so and so.valid) then 
		return 
	end
	if (so.skin ~= "scarf") then 
		return 
	end
	if (skins["samus"] == nil) then 
		return 
	end
	if (gametype ~= GT_COOP) then 
		return 
	end
	so.samusforcetext = true
	SamusDialogue(so, "\x83Ha-ha-ha!", nil, "SCFH5", 2, 0, 105-17)
	S_StartSound(so, sfx_scf1)
end, MT_METROIDPART)

addHook("MobjDeath", function(s, i, so)
	if not (so and so.player)
		return true
	end
	if not (so and so.valid) then 
		return 
	end
	if (so.skin ~= "scarf") then 
		return 
	end
	if (skins["samus"] == nil) then 
		return 
	end
	if (gametype ~= GT_COOP) then 
		return 
	end
	so.samusforcetext = true
	SamusDialogue(so, "\x85Not so fast...commander", nil, "SCFH5", 2, 0, 105-17)
	S_StartSound(so, sfx_scf12)
end, MT_METALSONIC_BATTLE)

local function Scarf_PreThinkJump(player)
	P_DoJump(player, true)
	player.cmd.buttons = $1 | BT_JUMP
	player.pflags = $1 | PF_JUMPDOWN
end

local function Scarf_RestoreAbility(player)
	player.secondjump = 0
	player.pflags = $1 & ~PF_THOKKED
end

local function Scarf_RemoveAbility(player)
	player.secondjump = UINT8_MAX
	player.pflags = $1 | PF_THOKKED
end

local function PainJumpSamus(player)
	if not (player.mo and player.mo.valid)
		return
	end
	local mo = player.mo

	local latency = 0
	pcall(function()
		latency = player.cmd.latency
	end)
	if (mo.coyoteTime == nil)
		mo.coyoteTime = 0
	end

	if (mo.recoveryWait == nil)
		mo.recoveryWait = 0
	end

	if (player.exiting)
		return
	end

	local pressedJump = false
	if (player.cmd.buttons & BT_JUMP) and not (player.pflags & PF_JUMPDOWN)
		pressedJump = true
	end

	if (P_PlayerInPain(player) == true)
		mo.coyoteTime = 0
		mo.recoveryWait = $1 + 1
		if (pressedJump == true)
			local baseRecoveryWait = (2*TICRATE)/3
			if (mo.recoveryWait > baseRecoveryWait - latency)
				Scarf_PreThinkJump(player)
				Scarf_RemoveAbility(player)
				player.mo.momx = 0
				player.mo.momy = 0
			end
		end
		return
	end
	mo.recoveryWait = 0
	local baseCoyoteTime = TICRATE/4
	local canJump = false
end

addHook("PreThinkFrame", function()
	for player in players.iterate do
		if player.mo and player.mo.valid and player.mo.skin == "scarf"
			if (skins["samus"] == nil) then 
				return 
			end
			PainJumpSamus(player)
		end
	end
end)
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	
local function SuperTramsformation(player)
	if not (player.mo and player.mo.valid and player.playerstate == PST_LIVE and player.mo.skin == "scarf") then return end 
	if player.cmd.buttons & BT_CUSTOM3
	and cupasoupbitch(player)
		player.charflags = $|SF_SUPER
		P_DoSuperTransformation(player)
		player.turnedsuper = true
		if player.rings < 149
			for i = 0, 6	
				local fa = (i*(ANGLE_180/3))
				local spawnemerald = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z + player.mo.height/2, player.spawnemerald)
				spawnemerald.radius = 5*FRACUNIT
				spawnemerald.dodgetimer = 4
				P_TeleportMove(spawnemerald, spawnemerald.x + FixedMul(sin(fa),spawnemerald.radius), spawnemerald.y + FixedMul(cos(fa),spawnemerald.radius), spawnemerald.z + player.mo.height/2)
				spawnemerald.playerparent = player.mo
				spawnemerald.goingin = nil
				spawnemerald.fa = fa
				player.spawnemerald = $ + 1
			end
		else
			for i = 0, 6	
				local fa = (i*(ANGLE_180/3))
				local spawnstarball = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z + player.mo.height/2, player.spawnstarball)
				spawnstarball.radius = 5*FRACUNIT
				spawnstarball.dodgetimer = 4
				P_TeleportMove(spawnstarball, spawnstarball.x + FixedMul(sin(fa),spawnstarball.radius), spawnstarball.y + FixedMul(cos(fa),spawnstarball.radius), spawnstarball.z + player.mo.height/2)
				spawnstarball.playerparent = player.mo
				spawnstarball.goingin = nil
				spawnstarball.fa = fa
				player.spawnstarball = $ + 1
			end
		end
	elseif (player.charflags & SF_SUPER)
	and not player.powers[pw_super]
	and not (maptol & TOL_NIGHTS)
		if player.rings < 149
			player.spawnemerald = MT_SCARF_EMERALD1
		else
			player.spawnstarball = MT_STARBALL1
		end
	end
	if player.turnedsuper
	and P_IsObjectOnGround(player.mo)
		player.turnedsuper = false
	end
end

addHook("PlayerThink", SuperTramsformation)

local function EmeraldMovement(emerald)
	if emerald and emerald.valid
		if emerald.radius > 0
			if emerald.radius < 60 * FRACUNIT
			and not emerald.goingin
				emerald.radius = $ + (5*FRACUNIT)
			elseif emerald.radius == 60*FRACUNIT
			and not emerald.goingin
				if emerald.dodgetimer > 0
					emerald.dodgetimer = $ - 1
				else
					emerald.goingin = true
				end
			elseif emerald.radius
			and emerald.goingin
				emerald.radius = $ - (3*FRACUNIT)
			end
			P_TeleportMove(emerald, emerald.playerparent.x + FixedMul(sin(emerald.fa),emerald.radius), emerald.playerparent.y + FixedMul(cos(emerald.fa),emerald.radius), emerald.playerparent.z + emerald.playerparent.height/2)
			emerald.fa = $ + (ANGLE_180/24)
		else
			P_RemoveMobj(emerald)
		end
	end
end

addHook("MobjThinker", EmeraldMovement, MT_STARBALL1)
addHook("MobjThinker", EmeraldMovement, MT_STARBALL2)
addHook("MobjThinker", EmeraldMovement, MT_STARBALL3)
addHook("MobjThinker", EmeraldMovement, MT_STARBALL4)
addHook("MobjThinker", EmeraldMovement, MT_STARBALL5)
addHook("MobjThinker", EmeraldMovement, MT_STARBALL6)
addHook("MobjThinker", EmeraldMovement, MT_STARBALL7)

addHook("MobjThinker", EmeraldMovement, MT_SCARF_EMERALD1)
addHook("MobjThinker", EmeraldMovement, MT_SCARF_EMERALD2)
addHook("MobjThinker", EmeraldMovement, MT_SCARF_EMERALD3)
addHook("MobjThinker", EmeraldMovement, MT_SCARF_EMERALD4)
addHook("MobjThinker", EmeraldMovement, MT_SCARF_EMERALD5)
addHook("MobjThinker", EmeraldMovement, MT_SCARF_EMERALD6)
addHook("MobjThinker", EmeraldMovement, MT_SCARF_EMERALD7)

addHook("AbilitySpecial", function(player)
	//Float Dash
	if (player.mo and player.mo.valid and player.mo.skin == "scarf" and player.playerstate == PST_LIVE)
	and player.charability == CA_NONE
	and not (player.pflags & PF_THOKKED)
	and not player.armaform
	and not (P_IsObjectOnGround(player.mo))
	and not (player.gotflag or player.gotcrystal)
		S_StartSound(player.mo, sfx_sfdsh)
		player.mo.sworddash = 18
		player.mo.swordstate = 0
		player.pflags = $1|PF_THOKKED
		local floatdash = P_SpawnMobj(player.mo.x, player.mo.y, (player.mo.z + 36 * player.mo.scale), MT_THOK)
		floatdash.state = S_SCARFDASH
		floatdash.color = SKINCOLOR_RED
		floatdash.scale = player.mo.scale/2+FRACUNIT/4
		floatdash.colorized = true
		floatdash.blendmode = AST_ADD
		floatdash.frame = $|FF_PAPERSPRITE|FF_TRANS50
		floatdash.angle = player.mo.angle + ANGLE_90
		if P_RandomChance(FRACUNIT/70) then 
			S_StartSound(player.mo, sfx_scf2) 
		end
		if player.mo.swordmah and player.mo.swordmah.valid then
			P_KillMobj(player.mo.swordmah)
			player.mo.swordmah = nil
		end
	end
	//Gravity Jump
	if (player.mo and player.mo.valid and player.mo.skin == "scarf" and player.playerstate == PST_LIVE)
	and player.charability == CA_NONE
	and not player.armaform
	and not (P_IsObjectOnGround(player.mo))
	and not (player.gotflag or player.gotcrystal)
		if not player.mo.sworddash
		and (player.mo.state == S_PLAY_FALL)
			player.mo.swordjump = 15
			player.mo.swordstate = 0
			S_StartSound(player.mo, sfx_sfdsh)
			player.mo.state = S_PLAY_SPRING
			local gravityjump = P_SpawnMobj(player.mo.x, player.mo.y, (player.mo.z + 36 * player.mo.scale), MT_THOK)
			gravityjump.state = S_SCARFDASH
			gravityjump.color = SKINCOLOR_RED
			gravityjump.scale = player.mo.scale/2+FRACUNIT/4
			gravityjump.colorized = true
			gravityjump.blendmode = AST_ADD
			gravityjump.frame = $|FF_FLOORSPRITE|FF_TRANS50
			if P_RandomChance(FRACUNIT/70) then 
				S_StartSound(player.mo, sfx_scf9)
			end
			if player.mo.swordmah and player.mo.swordmah.valid then
				P_KillMobj(player.mo.swordmah)
				player.mo.swordmah = nil
			end
		end
	end
end)

addHook("MobjCollide", function(spike, plmo)
    if not (plmo and plmo.valid and plmo.skin == "scarf") then return end
	if plmo.type ~= MT_PLAYER then return end
	if plmo.z + plmo.height < spike.z or spike.z + spike.height < plmo.z then return end
	local player = plmo.player
	if player.mo.swordstate > 1
		P_KillMobj(spike, plmo, plmo)
    end
end, MT_SPIKE)

addHook("MobjCollide", function(spike, plmo)
    if not (plmo and plmo.valid and plmo.skin == "scarf") then return end
	if plmo.type ~= MT_PLAYER then return end
	if (plmo.z > spike.z+spike.height*4) or (spike.z > plmo.z+plmo.height*2) then return end
	local player = plmo.player
	if player.mo.swordstate > 1
		P_KillMobj(spike, plmo, plmo)
    end
end, MT_WALLSPIKE)

addHook("MobjCollide", function(spike, plmo)
    if not (plmo and plmo.valid and plmo.skin == "scarf") then return end
	if plmo.type ~= MT_PLAYER then return end
	if plmo.z + plmo.height < spike.z or spike.z + spike.height < plmo.z then return end
	local player = plmo.player
	if player.powers[pw_sneakers]
	and player.speed >= player.runspeed
		P_KillMobj(spike, plmo, plmo)
    end
end, MT_SPIKE)

addHook("MobjCollide", function(spike, plmo)
    if not (plmo and plmo.valid and plmo.skin == "scarf") then return end
	if plmo.type ~= MT_PLAYER then return end
	if (plmo.z > spike.z+spike.height*4) or (spike.z > plmo.z+plmo.height*2) then return end
	local player = plmo.player
	if player.powers[pw_sneakers]
	and player.speed >= player.runspeed
		P_KillMobj(spike, plmo, plmo)
    end
end, MT_WALLSPIKE)

addHook("PlayerCanDamage", function(player)
	if (player.mo.skin == "scarf")
		if player.powers[pw_sneakers]
		and player.speed >= player.runspeed then
			return true
		end
    end
end)

addHook("MobjThinker", function(mobj)
	if mobj and mobj.valid
	if not mobj.source return end
		mobj.lifetime = $ or 0
		P_TeleportMove(mobj, mobj.x + mobj.lifetime * mobj.momx, mobj.y + mobj.lifetime * mobj.momy, mobj.z + 17*FRACUNIT + mobj.lifetime * mobj.momz)
		mobj.lifetime = $ + 1
	end
end, MT_ELECTRICJUMPPARTICLE)

addHook("MobjThinker", function(mo)
	if mo and mo.valid 
	and mo.type == MT_LIGHTBURST
		mo.color = SKINCOLOR_SKY
		mo.colorized = true
		mo.blendmode = AST_ADD
		local sparkle = P_SpawnMobjFromMobj(mo, P_RandomRange(-10, 10) * FRACUNIT, P_RandomRange(-10, 10) * FRACUNIT, 20*FRACUNIT + 15*FRACUNIT, MT_ELECTRICJUMPPARTICLE)
		sparkle.momx = P_RandomRange(-5, 5) * FRACUNIT
		sparkle.momy = P_RandomRange(-5, 5) * FRACUNIT
		sparkle.momz =  P_RandomRange(-5, 5) * FRACUNIT
		sparkle.scale = mo.scale/3*2
		sparkle.source = mo
	end
end, MT_LIGHTBURST)

// death animation
local function ScarfDeath(target, inflictor, source, damage)
	if target
	and target.player
		if target.skin == "scarf"
			if damage == DMG_FIRE
				target.player.scarf_burnt = true
				return false
			elseif damage == DMG_ELECTRIC
				target.player.scarf_elec = true
				return false
			elseif damage == DMG_SPIKE
				target.player.scarf_spike = true
				return false
			elseif damage == DMG_DROWNED or damage == DMG_SPACEDROWN
				target.player.scarf_drowned = true
				return false
			elseif damage == DMG_DEATHPIT
				target.player.scarf_deathpit = true
				return false
			elseif damage == DMG_CRUSHED
				target.player.scarf_crushed = true
				return false
			end
		end
	end
end

addHook("MobjDeath", ScarfDeath)

local function DeathUnset(player)
	player.scarf_burnt = false
	player.scarf_elec = false
	player.scarf_spike = false
	player.scarf_drowned = false
	player.scarf_deathpit = false
	player.scarf_crushed = false
end

addHook("PlayerSpawn", DeathUnset)

local function StateDeath(player)
	if player.scarf_burnt
		if not (leveltime & 3)
			local burndeath = P_SpawnMobj(player.mo.x+(P_RandomRange(-10,10)*FRACUNIT),player.mo.y+(P_RandomRange(-10,10)*FRACUNIT),player.mo.z+(P_RandomRange(-10,10)*FRACUNIT),MT_FLAMEPARTICLE)
			burndeath.color = SKINCOLOR_RED
			burndeath.colorized = true
			burndeath.blendmode = AST_ADD
			burndeath.flags = $1|MF_NOCLIP|MF_NOCLIPHEIGHT
		end
		if player.mo.state == S_PLAY_DEAD
			S_StartSound(player.mo, sfx_cdfm42)
			S_StartSound(player.mo, sfx_s3k5d)
			P_FlashPal(player, PAL_NUKE, 3)
			P_StartQuake(9*FRACUNIT, 3)
			if P_PlayerTouchingSectorSpecial(player, 1, 3) and P_IsObjectOnGround(player.mo)
				for d = 1,6
					local burningparticle = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_SPINDUST)
					P_InstaThrust(burningparticle, ANGLE_45*d, 20*player.mo.scale)
					burningparticle.scale = player.mo.scale
					burningparticle.state = S_LAVASPLISH
					burningparticle.flags = $ & ~MF_NOGRAVITY
					P_SetObjectMomZ(burningparticle, 7*player.mo.scale)
				end
				for c = 1,12
					local burningparticle2 = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_PUMATRAIL)
					P_InstaThrust(burningparticle2, (ANGLE_45/2)*c, 30*player.mo.scale)
					burningparticle2.scale = player.mo.scale
					burningparticle2.flags = $ & ~MF_NOGRAVITY
					P_SetObjectMomZ(burningparticle2, 14*player.mo.scale)
				end
			end
		end
		if player.deathstart
			S_StartSound(s, sfx_s3k48)
		end
		player.mo.state = S_SCARF_BURN
		player.mo.rollangle = $+ANGLE_22h
	elseif player.scarf_elec
		player.mo.rollangle = $+ANGLE_22h
		if not (leveltime & 3)
			local electrodeath = P_SpawnMobj(player.mo.x+(P_RandomRange(-10,10)*FRACUNIT),player.mo.y+(P_RandomRange(-10,10)*FRACUNIT),player.mo.z+(P_RandomRange(-10,10)*FRACUNIT),MT_WATERZAP)
			electrodeath.blendmode = AST_ADD
			electrodeath.frame = FF_TRANS50
			electrodeath.color = P_RandomRange(SKINCOLOR_SUPERORANGE3, SKINCOLOR_SUPERGOLD1, SKINCOLOR_YELLOW)
			electrodeath.colorized = true
			electrodeath.scale = $*P_RandomRange(2,6)
			electrodeath.rollangle = player.mo.rollangle+(P_RandomRange(-90,90)*ANG1)
			electrodeath.tics = $+P_RandomRange(2,15)
			electrodeath.frame = $|FF_FULLBRIGHT
			electrodeath.flags = $1|MF_NOCLIP|MF_NOCLIPHEIGHT
			local electricghost = P_SpawnGhostMobj(player.mo)
			P_InstaThrust(electricghost, P_RandomRange(1,359)*ANG1, 6*player.mo.scale)
			P_SetObjectMomZ(electricghost, P_RandomRange(3,-2)*player.mo.scale, true)
			electricghost.rollangle = player.mo.rollangle+(P_RandomRange(-40,40)*ANG1)
			electricghost.spriteyscale = $*4/P_RandomRange(1,10)
			electricghost.spritexscale = $*4/P_RandomRange(1,10)
			electricghost.color = P_RandomRange(SKINCOLOR_SUPERORANGE3, SKINCOLOR_SUPERGOLD1, SKINCOLOR_YELLOW)
			electricghost.colorized = true
			electricghost.blendmode = AST_ADD
			electricghost.state = S_SCARF_BURN
		end
		if player.mo.state == S_PLAY_DEAD
			P_FlashPal(player, PAL_WHITE, 3)
			S_StartSound(player.mo, sfx_buzz2)
		end
		if (leveltime & 1) == 0
			player.mo.state = S_SCARF_ELECTRO1
		else
			player.mo.state = S_SCARF_ELECTRO3
		end
	elseif player.scarf_spike
		player.mo.state = S_SCARF_BURN
		player.mo.rollangle = $+ANGLE_22h
		if player.mo.state == S_PLAY_DEAD
			S_StartSound(player.mo, sfx_cdfm42)
			S_StartSound(player.mo, sfx_s3k5d)
			P_FlashPal(player, PAL_RECYCLE, 3)
			P_StartQuake(9*FRACUNIT, 3)
		end
	elseif player.scarf_drowned
		if player.mo.state == S_PLAY_DEAD
			S_StartSound(player.mo, sfx_cdfm42)
			S_StartSound(player.mo, sfx_s3k5d)
			P_FlashPal(player, PAL_WHITE, 3)
			P_StartQuake(9*FRACUNIT, 3)
		end
		player.mo.state = S_SCARF_BURN
		player.mo.rollangle = $+ANGLE_22h
	elseif player.scarf_deathpit
		if player.mo.state == S_PLAY_DEAD
			S_StartSound(player.mo, sfx_cdfm42)
			S_StartSound(player.mo, sfx_s3k5d)
		end
		player.mo.state = S_PLAY_FALL
		P_SetObjectMomZ(player.mo, -15*FRACUNIT, false)
	elseif player.scarf_crushed
		if player.mo.state == S_PLAY_DEAD
			S_StartSound(player.mo, sfx_cdfm42)
			S_StartSound(player.mo, sfx_s3k5d)
		end
		player.mo.state = S_SCARF_CRUSH
		player.mo.flags = $ & ~MF_NOCLIP
		player.mo.flags = $ & ~MF_NOCLIPHEIGHT
	end
end

addHook("PlayerThink", StateDeath)

addHook("ShouldDamage", function(mo, inflictor, source, damage, damagetype)
	if mo and mo.valid and mo.skin == "scarf"
	and mo.scarfdodge > 1
		if inflictor and inflictor.valid and inflictor.flags & MF_BOXICON
		or damagetype & DMG_DEATHMASK
			return
		end
		return false
	end
end, MT_PLAYER)

addHook("ShouldDamage", function(mo, inf)
	if mo and mo.valid and mo.player
		if inf and inf.valid and inf.type == MT_SWORDDAMAGE
			if CBW_Battle
				return false
			end
		end
	end
end, MT_PLAYER)

addHook("ShouldDamage", function(mo, inf)
	if mo and mo.valid and mo.player
		if inf and inf.valid and inf.type == MT_SCARFSHOT and inf.health
			if CBW_Battle
			or G_RingSlingerGametype()
				inf.state = S_SCARDSHOTEPLODE1
				inf.momx = 0
				inf.momz = 0
				inf.momy = 0
				P_KillMobj(inf)
			end
		end
	end
end, MT_PLAYER)

addHook("ShouldDamage", function(mobj, inf)
	if mobj and mobj.valid 
	and (mobj.flags & (MF_ENEMY|MF_MONITOR|MF_BOSS))
		if inf and inf.valid and inf.type == MT_SCARFSHOT and inf.health
			inf.state = S_SCARDSHOTEPLODE1
			inf.momx = 0
			inf.momz = 0
			inf.momy = 0
			P_KillMobj(inf)
		end
		if mobj.type == MT_METROID
		and not mobj.state == S_MTRDFROZEN
			return false
		end
		if mobj.type == MT_SUPERMETROID
		and not mobj.state == S_MTRDFROZEN
			return false
		end
	end
end)

addHook("MusicChange", function(oldname, newname)
	if consoleplayer
		local scarf_music = skins[consoleplayer.skin].name
		if scarf_music == "scarf"
			if (newname == "_CLEAR" or newname == "_clear") then
				return "SCCLR"
			end
			if newname == "_1up"
				return "SCR1UP"
			end
		end
	end
end)

addHook("MobjDamage", function(mo)
	if mo and mo.valid and mo.player and mo.skin == "scarf"
	and mo.player.playerstate == PST_LIVE
	and not (mo.player.powers[pw_carry] == CR_NIGHTSMODE)
		S_StartSound(mo, sfx_scfht)
	end
end, MT_PLAYER)

addHook("MobjDeath", function(mo)
	if mo and mo.valid and mo.player and mo.skin == "scarf"
	and not (mo.player.powers[pw_carry] == CR_NIGHTSMODE)
		S_StopSoundByID(mo, sfx_scfht)
	end
end, MT_PLAYER)

print("\n"+"\x89\Scarf The Wolf \x80\- \x88\Sprites by Mr.FondusBroMan.", "\x87\Coding by Mr.FondusBroMan", "\x81\Scarf The Wolf V2.6")
print("\n"+"\x85"+"Scarf The Wolf\x80 for [SRB2 2.2.9+]"+"\n")